*** Before running this syntax, enter the country test date ***.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

compute pfyear= RND((pfbirth/100-TRUNC(pfbirth/100))*100).
Recode pfyear (0=sysmis) (63=sysmis) (93 thru 99=sysmis).
if  pbyear ~=pfyear or missing(pbyear)  pbyear=pfyear.
Recode pbyear (missing=sysmis) (0=sysmis)  (93 thru 99=sysmis).

***** Aggregating at class level *****.

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.SAV'
  /BREAK=country region district idschool idclass 
  /meancls= MEAN(pbyear) /miscls= NMISS(pbyear)
  /numcls=N (idpupil).

***** Aggregating at school level *****.

sort cases by country (a) region (a) district (a) idschool (a)  .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.SAV'
  /BREAK=country region district idschool 
  /meansch= MEAN(pbyear) /missch= NMISS(pbyear)
  /numsch=N (idpupil).

***** Aggregating at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /meandis= MEAN(pbyear) /misdis= NMISS(pbyear)
  /numdis=N (idpupil).

***** Aggregating at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /meanreg= MEAN(pbyear) /misreg= NMISS(pbyear)
  /numreg=N (idpupil).

***** Aggregating at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /meancon= MEAN(pbyear) /miscon= NMISS(pbyear)
  /numcon=N (idpupil).

***** Merging back the calculation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

compute pfyear= RND((pfbirth/100-TRUNC(pfbirth/100))*100).
Recode pfyear (0=sysmis) (63=sysmis) (93 thru 99=sysmis).
if  pbyear ~=pfyear or missing(pbyear)  pbyear=pfyear.
Recode pbyear (missing=sysmis) (0=sysmis)  (93 thru 99=sysmis).

FREQUENCIES
  VARIABLES=pbyear 
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.sav'
 /BY country region district idschool idclass .
EXECUTE.

sort cases by country (a) region (a) district (a) idschool (a)  .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.sav'
 /BY country region district idschool .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misclspc=  miscls/ numcls.
compute misschpc= missch/ numsch.
compute misdispc= misdis/numdis.
compute misregpc= misreg/numreg.
compute misconpc= miscon/numcon.
EXECUTE .

if (missing(pbyear) and misclspc~= 0 and misclspc LT .15) pbyear=RND(meancls).
FREQUENCIES
  VARIABLES=pbyear 
  /ORDER  ANALYSIS .

if (missing(pbyear) and misclspc GE .15 and misschpc~= 0 and misschpc LT .15)  pbyear=RND(meansch).
FREQUENCIES
  VARIABLES=pbyear 
  /ORDER  ANALYSIS .

if (missing(pbyear) and misclspc GE .15 and misschpc GE .15 and misdispc~= 0 and misdispc LT .15) pbyear=RND(meandis).
FREQUENCIES
  VARIABLES=pbyear 
  /ORDER  ANALYSIS .

if (missing(pbyear) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc~= 0 and misregpc LT .15) pbyear=RND(meanreg).
FREQUENCIES
  VARIABLES=pbyear 
  /ORDER  ANALYSIS .

if (missing(pbyear) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc GE .15 and misconpc~= 0 and misconpc LT .15) pbyear=RND(meancon).
FREQUENCIES
  VARIABLES=pbyear 
  /ORDER  ANALYSIS .

if (missing(pbyear) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc GE .15 and misconpc GE .15) pbyear=pbyear.
FREQUENCIES
  VARIABLES=pbyear 
  /ORDER  ANALYSIS .

if missing(pfyear) pfyear=pbyear.

compute pfmonth=trunc(pfbirth/100)-(trunc(pfbirth/10000)*100).
recode pfmonth (0=sysmis) (13 thru 99=sysmis) .
Recode pbmonth (0=sysmis) (13 thru 99=sysmis).
if missing(pfmonth) and not(missing(pbmonth)) pfmonth=pbmonth.
if missing(pbmonth) and not(missing(pfmonth)) pbmonth=pfmonth.
if missing(pbmonth) pbmonth=6.
if missing(pfmonth) pfmonth=6.
if pbmonth~=pfmonth pbmonth=pfmonth.

compute pfday=trunc(pfbirth/10000).
recode pfday (0=sysmis) (98 thru 99=sysmis) .
Recode pbday (0=sysmis) (88 thru 99=sysmis).
if missing(pfday) and not(missing(pbday)) pfday=pbday.
if missing(pbday) and not(missing(pfday)) pbday=pfday.
if missing(pbday) pbday=15.
if missing(pfday) pfday=15.
if pbday~=pfday pbday=pfday.

compute pfbirth=pfday*10000+pfmonth*100+pfyear.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating derived variable *****.

DO IF country="BOT".
  compute testmon=10.
  compute testyr=100.
END IF.

DO IF country="KEN".
  compute testmon=10.
  compute testyr=100.
END IF.

DO IF country="LES".
  compute testmon=9.
  compute testyr=100.
END IF.

DO IF country="MAL".
  compute testmon=10.
  compute testyr=102.
END IF.

DO IF country="MAU".
  compute testmon=8.
  compute testyr=101.
END IF.

DO IF country="MOZ".
  compute testmon=9.
  compute testyr=100.
END IF.

DO IF country="NAM".
  compute testmon=9.
  compute testyr=100.
END IF.

DO IF country="SEY".
  compute testmon=7.
  compute testyr=100.
END IF.

DO IF country="SOU".
  compute testmon=10.
  compute testyr=100.
END IF.

DO IF country="SWA".
  compute testmon=10.
  compute testyr=100.
END IF.

DO IF country="TAN".
  compute testmon=11.
  compute testyr=100.
END IF.

DO IF country="UGA".
  compute testmon=10.
  compute testyr=100.
END IF.

DO IF country="ZAM".
  compute testmon=9.
  compute testyr=100.
END IF.

DO IF country="ZAN".
  compute testmon=11.
  compute testyr=100.
END IF.

compute zpagemon=(testyr*12+testmon)-(pbyear*12+pbmonth).

FREQUENCIES
  VARIABLES=zpagemon  pfbirth
  /FORMAT=NOTABLE
  /ORDER  ANALYSIS .

***** Saving imputed and derived variables *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\PQ02_pfbirth.sav' /keep country stratum idpupil pbday pbmonth pbyear pfbirth zpagemon.

***** Table3.1 (B) Mean Age in Month by Strata *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=zpagemon  BY stratum
  /CELLS MEAN COUNT STDDEV  .
