GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

***** Aggregating at class level *****.

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.SAV'
  /BREAK=country region district idschool idclass 
  /miscls= NMISS(pstay)
  /numcls=N (idpupil)
  /opt_1cls = PIN(pstay 1 1)
  /opt_2cls = PIN(pstay 2 2)
  /opt_3cls = PIN(pstay 3 3)
  /opt_4cls = PIN(pstay 4 4)
.

***** Aggregating at school level *****.

sort cases by country (a) region (a) district (a) idschool (a)  .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.SAV'
  /BREAK=country region district idschool 
  /missch= NMISS(pstay)
  /numsch=N (idpupil)
  /opt_1sch = PIN(pstay 1 1)
  /opt_2sch = PIN(pstay 2 2)
  /opt_3sch = PIN(pstay 3 3)
  /opt_4sch = PIN(pstay 4 4)
.

***** Aggregating at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /misdis= NMISS(pstay)
  /numdis=N (idpupil)
  /opt_1dis = PIN(pstay 1 1)
  /opt_2dis = PIN(pstay 2 2)
  /opt_3dis = PIN(pstay 3 3)
  /opt_4dis = PIN(pstay 4 4)
.

***** Aggregating at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /misreg= NMISS(pstay)
  /numreg=N (idpupil)
  /opt_1reg = PIN(pstay 1 1)
  /opt_2reg = PIN(pstay 2 2)
  /opt_3reg = PIN(pstay 3 3)
  /opt_4reg = PIN(pstay 4 4)
.

***** Aggregating at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /miscon= NMISS(pstay)
  /numcon=N (idpupil)
  /opt_1con = PIN(pstay 1 1)
  /opt_2con = PIN(pstay 2 2)
  /opt_3con = PIN(pstay 3 3)
  /opt_4con = PIN(pstay 4 4)
.

***** Merging back the different aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=pstay
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.sav'
 /BY country region district idschool idclass .
EXECUTE.

sort cases by country (a) region (a) district (a) idschool (a)  .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.sav'
 /BY country region district idschool .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misclspc=  miscls/ numcls.
compute misschpc= missch/ numsch.
compute misdispc= misdis/numdis.
compute misregpc= misreg/numreg.
compute misconpc= miscon/numcon.
EXECUTE .

***** Finding the Mode at each level *****.

if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls)=opt_4cls modecls=4.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls)=opt_3cls modecls=3.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls)=opt_2cls modecls=2.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls)=opt_1cls modecls=1.

if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch)=opt_4sch modesch=4.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch)=opt_3sch modesch=3.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch)=opt_2sch modesch=2.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch)=opt_1sch modesch=1.

if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis)=opt_4dis modedis=4.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis)=opt_3dis modedis=3.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis)=opt_2dis modedis=2.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis)=opt_1dis modedis=1.

if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg)=opt_4reg modereg=4.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg)=opt_3reg modereg=3.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg)=opt_2reg modereg=2.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg)=opt_1reg modereg=1.

if max(opt_1con, opt_2con, opt_3con, opt_4con)=opt_4con modecon=4.
if max(opt_1con, opt_2con, opt_3con, opt_4con)=opt_3con modecon=3.
if max(opt_1con, opt_2con, opt_3con, opt_4con)=opt_2con modecon=2.
if max(opt_1con, opt_2con, opt_3con, opt_4con)=opt_1con modecon=1.

***** Imputation at class level *****.

if (missing(pstay) and misclspc~= 0 and misclspc LT .15) pstay=modecls.

FREQUENCIES
  VARIABLES=pstay
  /ORDER  ANALYSIS .

***** Imputation at school level *****.

if (missing(pstay) and misclspc GE .15 and misschpc~= 0 and misschpc LT .15) pstay=modesch.

FREQUENCIES
  VARIABLES=pstay
  /ORDER  ANALYSIS .

***** Imputation at district level *****.

if (missing(pstay) and misclspc GE .15 and misschpc GE .15 and misdispc~= 0 and misdispc LT .15) pstay=modedis.

FREQUENCIES
  VARIABLES=pstay
  /ORDER  ANALYSIS .

***** Imputation at region level *****.

if (missing(pstay) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc~= 0 and misregpc LT .15) pstay=modereg.

FREQUENCIES
  VARIABLES=pstay
  /ORDER  ANALYSIS .

***** Imputation at country level *****.

if (missing(pstay) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc GE .15 and misconpc~= 0 and misconpc LT .15) pstay=modecon.

FREQUENCIES
  VARIABLES=pstay
  /ORDER  ANALYSIS .

***** No imputation if more than 15% missing at country level *****.

if (missing(pstay) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc GE .15 and misconpc GE .15) pstay=pstay.

FREQUENCIES
  VARIABLES=pstay
  /ORDER  ANALYSIS .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** saving imputed values *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\PQ05.sav' /keep country stratum  idpupil pstay.

***** Table 3.3(b) Where to stay *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

CROSSTABS
  /TABLES=stratum  BY pstay
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT ROW .
