GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

***** Aggregating at class level *****.

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.SAV'
  /BREAK=country region district idschool idclass 
  /miscls= NMISS(pbookshm) 
  /numcls=N (idpupil)
  /opt_1cls = PIN(pbookshm 1 1)
  /opt_2cls = PIN(pbookshm 2 2)
  /opt_3cls = PIN(pbookshm 3 3)
  /opt_4cls = PIN(pbookshm 4 4)
  /opt_5cls = PIN(pbookshm 5 5)
  /opt_6cls = PIN(pbookshm 6 6)
.

***** Aggregating at school level *****.

sort cases by country (a) region (a) district (a) idschool (a)  .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.SAV'
  /BREAK=country region district idschool 
  /missch= NMISS(pbookshm) 
  /numsch=N (idpupil)
  /opt_1sch = PIN(pbookshm 1 1)
  /opt_2sch = PIN(pbookshm 2 2)
  /opt_3sch = PIN(pbookshm 3 3)
  /opt_4sch = PIN(pbookshm 4 4)
  /opt_5sch = PIN(pbookshm 5 5)
  /opt_6sch = PIN(pbookshm 6 6)
.

***** Aggregating at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /misdis= NMISS(pbookshm) 
  /numdis=N (idpupil)
  /opt_1dis = PIN(pbookshm 1 1)
  /opt_2dis = PIN(pbookshm 2 2)
  /opt_3dis = PIN(pbookshm 3 3)
  /opt_4dis = PIN(pbookshm 4 4)
  /opt_5dis = PIN(pbookshm 5 5)
  /opt_6dis = PIN(pbookshm 6 6)
.

***** Aggregating at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /misreg= NMISS(pbookshm) 
  /numreg=N (idpupil)
  /opt_1reg = PIN(pbookshm 1 1)
  /opt_2reg = PIN(pbookshm 2 2)
  /opt_3reg = PIN(pbookshm 3 3)
  /opt_4reg = PIN(pbookshm 4 4)
  /opt_5reg = PIN(pbookshm 5 5)
  /opt_6reg = PIN(pbookshm 6 6)
.

***** Aggregating at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /miscon= NMISS(pbookshm)
  /numcon=N (idpupil)
  /opt_1con = PIN(pbookshm 1 1)
  /opt_2con = PIN(pbookshm 2 2)
  /opt_3con = PIN(pbookshm 3 3)
  /opt_4con = PIN(pbookshm 4 4)
  /opt_5con = PIN(pbookshm 5 5)
  /opt_6con = PIN(pbookshm 6 6)
.

***** Merging back the different aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=pbookshm
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.sav'
 /BY country region district idschool idclass .
EXECUTE.

sort cases by country (a) region (a) district (a) idschool (a)  .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.sav'
 /BY country region district idschool .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misclspc=  miscls/ numcls.
compute misschpc= missch/ numsch.
compute misdispc= misdis/numdis.
compute misregpc= misreg/numreg.
compute misconpc= miscon/numcon.
EXECUTE .

***** Finding the Mode at each level *****.

if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls, opt_5cls, opt_6cls)=opt_6cls modecls=6.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls, opt_5cls, opt_6cls)=opt_5cls modecls=5.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls, opt_5cls, opt_6cls)=opt_4cls modecls=4.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls, opt_5cls, opt_6cls)=opt_3cls modecls=3.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls, opt_5cls, opt_6cls)=opt_2cls modecls=2.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls, opt_5cls, opt_6cls)=opt_1cls modecls=1.

if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch, opt_5sch, opt_6sch)=opt_6sch modesch=6.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch, opt_5sch, opt_6sch)=opt_5sch modesch=5.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch, opt_5sch, opt_6sch)=opt_4sch modesch=4.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch, opt_5sch, opt_6sch)=opt_3sch modesch=3.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch, opt_5sch, opt_6sch)=opt_2sch modesch=2.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch, opt_5sch, opt_6sch)=opt_1sch modesch=1.

if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis, opt_6dis)=opt_6dis modedis=6.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis, opt_6dis)=opt_5dis modedis=5.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis, opt_6dis)=opt_4dis modedis=4.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis, opt_6dis)=opt_3dis modedis=3.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis, opt_6dis)=opt_2dis modedis=2.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis, opt_6dis)=opt_1dis modedis=1.

if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg, opt_6reg)=opt_6reg modereg=6.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg, opt_6reg)=opt_5reg modereg=5.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg, opt_6reg)=opt_4reg modereg=4.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg, opt_6reg)=opt_3reg modereg=3.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg, opt_6reg)=opt_2reg modereg=2.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg, opt_6reg)=opt_1reg modereg=1.

if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con, opt_6con)=opt_6con modecon=6.
if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con, opt_6con)=opt_5con modecon=5.
if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con, opt_6con)=opt_4con modecon=4.
if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con, opt_6con)=opt_3con modecon=3.
if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con, opt_6con)=opt_2con modecon=2.
if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con, opt_6con)=opt_1con modecon=1.

***** Imputation at class level *****.

if (missing(pbookshm) and misclspc~= 0 and misclspc LT .15) pbookshm =modecls.

FREQUENCIES
  VARIABLES=pbookshm 
  /ORDER  ANALYSIS .

***** Imputation at school level *****.

if (missing(pbookshm) and misclspc GE .15 and misschpc~= 0 and misschpc LT .15) pbookshm =modesch.

FREQUENCIES
  VARIABLES=pbookshm 
  /ORDER  ANALYSIS .

***** Imputation at district level *****.

if (missing(pbookshm) and misclspc GE .15 and misschpc GE .15 and misdispc~= 0 and misdispc LT .15) pbookshm=modedis.

FREQUENCIES
  VARIABLES=pbookshm
  /ORDER  ANALYSIS .

***** Imputation at region level *****.

if (missing(pbookshm) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc~= 0 and misregpc LT .15) pbookshm=modereg.

FREQUENCIES
  VARIABLES=pbookshm
  /ORDER  ANALYSIS .

***** Imputation at country level *****.

if (missing(pbookshm) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc GE .15 and misconpc~= 0 and misconpc LT .15) pbookshm=modecon.

FREQUENCIES
  VARIABLES=pbookshm
  /ORDER  ANALYSIS .

***** No imputation if more than 15% missing at country level *****.

if (missing(pbookshm) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc GE .15 and misconpc GE .15) pbookshm=pbookshm.

FREQUENCIES
  VARIABLES=pbookshm
  /ORDER  ANALYSIS .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** calculating derived variable *****.

RECODE
  pbookshm
  (1=0)  (2=5)  (3=30)  (4=75)  (5=150)  (6=250)  INTO  zpbooksh .
EXECUTE .

***** saving imputed and derived variables *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\PQ06.sav' /keep country stratum idpupil pbookshm zpbooksh .

****Table 3.1(b) Pupil Sex*****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=zpbooksh BY stratum
  /CELLS MEAN COUNT STDDEV  .
