GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

***** Aggregating at class level *****.

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.SAV'
  /BREAK=country region district idschool idclass 
  /miscls= NMISS(plookwk) 
  /numcls=N (idpupil)
  /opt_1cls = PIN(plookwk 1 1)
  /opt_2cls = PIN(plookwk 2 2)
  /opt_3cls = PIN(plookwk 3 3)
.

***** Aggregating at school level *****.

sort cases by country (a) region (a) district (a) idschool (a)  .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.SAV'
  /BREAK=country region district idschool 
  /missch= NMISS(plookwk) 
  /numsch=N (idpupil)
  /opt_1sch = PIN(plookwk 1 1)
  /opt_2sch = PIN(plookwk 2 2)
  /opt_3sch = PIN(plookwk 3 3)
.

***** Aggregating at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /misdis= NMISS(plookwk) 
  /numdis=N (idpupil)
  /opt_1dis = PIN(plookwk 1 1)
  /opt_2dis = PIN(plookwk 2 2)
  /opt_3dis = PIN(plookwk 3 3)
.

***** Aggregating at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /misreg= NMISS(plookwk) 
  /numreg=N (idpupil)
  /opt_1reg = PIN(plookwk 1 1)
  /opt_2reg = PIN(plookwk 2 2)
  /opt_3reg = PIN(plookwk 3 3)
.

***** Aggregating at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /miscon= NMISS(plookwk)
  /numcon=N (idpupil)
  /opt_1con = PIN(plookwk 1 1)
  /opt_2con = PIN(plookwk 2 2)
  /opt_3con = PIN(plookwk 3 3)
.

***** Merging back the different aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=plookwk
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.sav'
 /BY country region district idschool idclass .
EXECUTE.

sort cases by country (a) region (a) district (a) idschool (a)  .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.sav'
 /BY country region district idschool .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

compute misclspc=  miscls/ numcls.
compute misschpc= missch/ numsch.
compute misdispc= misdis/numdis.
compute misregpc= misreg/numreg.
compute misconpc= miscon/numcon.
EXECUTE .

***** Finding the Mode at each level *****.

if max(opt_1cls, opt_2cls, opt_3cls)=opt_3cls modecls=3.
if max(opt_1cls, opt_2cls, opt_3cls)=opt_2cls modecls=2.
if max(opt_1cls, opt_2cls, opt_3cls)=opt_1cls modecls=1.

if max(opt_1sch, opt_2sch, opt_3sch)=opt_3sch modesch=3.
if max(opt_1sch, opt_2sch, opt_3sch)=opt_2sch modesch=2.
if max(opt_1sch, opt_2sch, opt_3sch)=opt_1sch modesch=1.

if max(opt_1dis, opt_2dis, opt_3dis)=opt_3dis modedis=3.
if max(opt_1dis, opt_2dis, opt_3dis)=opt_2dis modedis=2.
if max(opt_1dis, opt_2dis, opt_3dis)=opt_1dis modedis=1.

if max(opt_1reg, opt_2reg, opt_3reg)=opt_3reg modereg=3.
if max(opt_1reg, opt_2reg, opt_3reg)=opt_2reg modereg=2.
if max(opt_1reg, opt_2reg, opt_3reg)=opt_1reg modereg=1.

if max(opt_1con, opt_2con, opt_3con)=opt_3con modecon=3.
if max(opt_1con, opt_2con, opt_3con)=opt_2con modecon=2.
if max(opt_1con, opt_2con, opt_3con)=opt_1con modecon=1.

***** Imputation at class level *****.

if (missing(plookwk) and misclspc~= 0 and misclspc LT .15) plookwk=modecls.

FREQUENCIES
  VARIABLES=plookwk 
  /ORDER  ANALYSIS .

***** Imputation at school level *****.

if (missing(plookwk) and misclspc GE .15 and misschpc~= 0 and misschpc LT .15) plookwk=modesch.

FREQUENCIES
  VARIABLES=plookwk 
  /ORDER  ANALYSIS .

***** Imputation at district level *****.

if (missing(plookwk) and misclspc GE .15 and misschpc GE .15 and misdispc~= 0 and misdispc LT .15) plookwk=modedis.

FREQUENCIES
  VARIABLES=plookwk 
  /ORDER  ANALYSIS .

***** Imputation at region level *****.

if (missing(plookwk) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc~= 0 and misregpc LT .15) plookwk=modereg.

FREQUENCIES
  VARIABLES=plookwk 
  /ORDER  ANALYSIS .

***** Imputation at country level *****.

if (missing(plookwk) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc GE .15 and misconpc~= 0 and misconpc LT .15) plookwk=modecon.

FREQUENCIES
  VARIABLES=plookwk 
  /ORDER  ANALYSIS .

***** No imputation if more than 15% missing at country level *****.

if (missing(plookwk) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc GE .15 and misconpc GE .15) plookwk=plookwk.
recode plookwk (missing=sysmis).
FREQUENCIES
  VARIABLES=plookwk 
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

***** computing derived variable *****.

RECODE
  plookwk
  (1thru 2=0)  (3=1)  INTO  zplookwk .
EXECUTE .

***** saving imputed and derived variables *****.

FREQUENCIES
  VARIABLES=zplookwk 
  /ORDER  ANALYSIS .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav' /keep country region district idschool idclass idpupil stratum plookwk zplookwk.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

sort cases by country (a) stratum (a) idpupil (a).

MATCH FILES /FILE=*
 /FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\PQ24_25.sav'
 /FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\PQ26.sav'
 /FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\PQ27.sav'
 /FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\PQ28.sav'
 /FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\PQ29.sav'
 /BY country stratum idpupil.
EXECUTE.

recode phmwkdon phmwkhlp (1,2=1) (3=2) (4=3) into zphmwkdo zphmwkhe.
compute zpask=(pread+pcalc)/2  .
compute zpquest=(pquestr+pquestm)/2  .
compute zphmint=zphmwkdo +zphmwkhe+zpask+zpquest+ plookwk.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\PQ30_zphmint.sav' /keep country stratum idpupil plookwk zplookwk zphmwkdo zphmwkhe zpask zpquest zphmint.

***** Table 9.7(a) Look at school work done *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=zplookwk  BY stratum
  /CELLS MEAN COUNT STDDEV  .
execute.

****** Table X: Home Interest *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=zpask zpquest zphmint  zphmwkdo zphmwkhe  BY stratum
  /CELLS MEAN COUNT STDDEV  .
execute.
