GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

***** Aggregating at class level *****.

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.SAV'
  /BREAK=country region district idschool idclass 
  /miscls= NMISS(ptextm) 
  /numcls=N (idpupil)
  /opt_1cls = PIN(ptextm 1 1)
  /opt_2cls = PIN(ptextm 2 2)
  /opt_3cls = PIN(ptextm 3 3)
  /opt_4cls = PIN(ptextm 4 4)
  /opt_5cls = PIN(ptextm 5 5)
.

***** Aggregating at school level *****.

sort cases by country (a) region (a) district (a) idschool (a)  .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.SAV'
  /BREAK=country region district idschool 
  /missch= NMISS(ptextm) 
  /numsch=N (idpupil)
  /opt_1sch = PIN(ptextm 1 1)
  /opt_2sch = PIN(ptextm 2 2)
  /opt_3sch = PIN(ptextm 3 3)
  /opt_4sch = PIN(ptextm 4 4)
  /opt_5sch = PIN(ptextm 5 5)
.

***** Aggregating at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /misdis= NMISS(ptextm) 
  /numdis=N (idpupil)
  /opt_1dis = PIN(ptextm 1 1)
  /opt_2dis = PIN(ptextm 2 2)
  /opt_3dis = PIN(ptextm 3 3)
  /opt_4dis = PIN(ptextm 4 4)
  /opt_5dis = PIN(ptextm 5 5)
.

***** Aggregating at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /misreg= NMISS(ptextm) 
  /numreg=N (idpupil)
  /opt_1reg = PIN(ptextm 1 1)
  /opt_2reg = PIN(ptextm 2 2)
  /opt_3reg = PIN(ptextm 3 3)
  /opt_4reg = PIN(ptextm 4 4)
  /opt_5reg = PIN(ptextm 5 5)
.

***** Aggregating at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /miscon= NMISS(ptextm)
  /numcon=N (idpupil)
  /opt_1con = PIN(ptextm 1 1)
  /opt_2con = PIN(ptextm 2 2)
  /opt_3con = PIN(ptextm 3 3)
  /opt_4con = PIN(ptextm 4 4)
  /opt_5con = PIN(ptextm 5 5)
.

***** Merging back the different aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=ptextm
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a) idschool (a)  idclass (a) .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCLS.sav'
 /BY country region district idschool idclass .
EXECUTE.

sort cases by country (a) region (a) district (a) idschool (a)  .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGSCH.sav'
 /BY country region district idschool .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

compute misclspc=  miscls/ numcls.
compute misschpc= missch/ numsch.
compute misdispc= misdis/numdis.
compute misregpc= misreg/numreg.
compute misconpc= miscon/numcon.
EXECUTE .

***** Finding the Mode at each level *****.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls, opt_5cls)=opt_5cls modecls=5.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls, opt_5cls)=opt_4cls modecls=4.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls, opt_5cls)=opt_3cls modecls=3.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls, opt_5cls)=opt_2cls modecls=2.
if max(opt_1cls, opt_2cls, opt_3cls, opt_4cls, opt_5cls)=opt_1cls modecls=1.

if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch, opt_5sch)=opt_5sch modesch=5.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch, opt_5sch)=opt_4sch modesch=4.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch, opt_5sch)=opt_3sch modesch=3.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch, opt_5sch)=opt_2sch modesch=2.
if max(opt_1sch, opt_2sch, opt_3sch, opt_4sch, opt_5sch)=opt_1sch modesch=1.

if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis)=opt_5dis modedis=5.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis)=opt_4dis modedis=4.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis)=opt_3dis modedis=3.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis)=opt_2dis modedis=2.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis, opt_5dis)=opt_1dis modedis=1.

if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg)=opt_5reg modereg=5.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg)=opt_4reg modereg=4.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg)=opt_3reg modereg=3.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg)=opt_2reg modereg=2.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg, opt_5reg)=opt_1reg modereg=1.

if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con)=opt_5con modecon=5.
if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con)=opt_4con modecon=4.
if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con)=opt_3con modecon=3.
if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con)=opt_2con modecon=2.
if max(opt_1con, opt_2con, opt_3con, opt_4con, opt_5con)=opt_1con modecon=1.

***** Imputation at class level *****.

if (missing(ptextm) and misclspc~= 0 and misclspc LT .15) ptextm=modecls.

FREQUENCIES
  VARIABLES=ptextm 
  /ORDER  ANALYSIS .

***** Imputation at school level *****.

if (missing(ptextm) and misclspc GE .15 and misschpc~= 0 and misschpc LT .15) ptextm=modesch.

FREQUENCIES
  VARIABLES=ptextm 
  /ORDER  ANALYSIS .

***** Imputation at district level *****.

if (missing(ptextm) and misclspc GE .15 and misschpc GE .15 and misdispc~= 0 and misdispc LT .15) ptextm=modedis.

FREQUENCIES
  VARIABLES=ptextm 
  /ORDER  ANALYSIS .

***** Imputation at region level *****.

if (missing(ptextm) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc~= 0 and misregpc LT .15) ptextm=modereg.

FREQUENCIES
  VARIABLES=ptextm 
  /ORDER  ANALYSIS .

***** Imputation at country level *****.

if (missing(ptextm) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc GE .15 and misconpc~= 0 and misconpc LT .15) ptextm=modecon.

FREQUENCIES
  VARIABLES=ptextm 
  /ORDER  ANALYSIS .

***** No imputation if more than 15% missing at country level *****.

if (missing(ptextm) and misclspc GE .15 and misschpc GE .15 and misdispc GE .15 and misregpc GE .15 and misconpc GE .15) ptextm=ptextm.
recode ptextm (missing=sysmis).
FREQUENCIES
  VARIABLES=ptextm 
  /ORDER  ANALYSIS .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** computing derived variable *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

RECODE
  ptextm
  (1thru 4=0)  (5=1)  INTO  zptextm .
EXECUTE .

***** saving imputed and derived variables *****.

FREQUENCIES
  VARIABLES=zptextm 
  /ORDER  ANALYSIS .

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\PQ38.sav' /keep country stratum idpupil ptextm zptextm .

***** Table 6.4 Own mathematics textbook *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=zptextm  BY stratum
  /CELLS MEAN COUNT STDDEV  .


