GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

if sexpthis=0 sexpthis=1.
if sexpall=0 sexpall=1.

count schmis=ssex to sprobcom (missing).

FILTER OFF.
USE ALL.
SELECT IF(schmis~=169).
EXECUTE .

***** Aggregating at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /meandis1= MEAN(sexpthis) /misdis1= NMISS(sexpthis)
  /meandis2= MEAN(sexpall) /misdis2= NMISS(sexpall)
  /numdis=N (idpupil).

***** Aggregating at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /meanreg1= MEAN(sexpthis) /misreg1= NMISS(sexpthis)
  /meanreg2= MEAN(sexpall) /misreg2= NMISS(sexpall)
  /numreg=N (idpupil).

***** Aggregating at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /meancon1= MEAN(sexpthis) /miscon1= NMISS(sexpthis)
  /meancon2= MEAN(sexpall) /miscon2= NMISS(sexpall)
  /numcon=N (idpupil).

***** Merging back the calculation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

if sexpthis=0 sexpthis=1.
if sexpall=0 sexpall=1.

count schmis=ssex to sprobcom (missing).

FILTER OFF.
USE ALL.
SELECT IF(schmis~=169).
EXECUTE .

FREQUENCIES
  VARIABLES=sexpthis sexpall
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misdisp1= misdis1/numdis.
compute misregp1= misreg1/numreg.
compute misconp1= miscon1/numcon.
compute misdisp2= misdis2/numdis.
compute misregp2= misreg2/numreg.
compute misconp2= miscon2/numcon.
EXECUTE .

***** Imputation of sexpthis*****.

if (schmis~=169 and missing(sexpthis) and misdisp1~= 0 and misdisp1 LT .15) sexpthis=RND(meandis1).
FREQUENCIES
  VARIABLES=sexpthis 
  /ORDER  ANALYSIS .

if (schmis~=169 and missing(sexpthis) and misdisp1 GE .15 and misregp1~= 0 and misregp1 LT .15) sexpthis=RND(meanreg1).
FREQUENCIES
  VARIABLES=sexpthis 
  /ORDER  ANALYSIS .

if (schmis~=169 and missing(sexpthis) and misdisp1 GE .15 and misregp1 GE .15 and misconp1~= 0 and misconp1 LT .15) sexpthis=RND(meancon1).
FREQUENCIES
  VARIABLES=sexpthis 
  /ORDER  ANALYSIS .

if (schmis~=169 and missing(sexpthis) and misdisp1 GE .15 and misregp1 GE .15 and misconp1 GE .15) sexpthis=sexpthis.
FREQUENCIES
  VARIABLES=sexpthis 
  /ORDER  ANALYSIS .

if (schmis~=169 and missing(sexpthis)) sexpthis=1.
FREQUENCIES
  VARIABLES=sexpthis 
  /ORDER  ANALYSIS .

***** Imputation of sexpall*****.

if (schmis~=169 and missing(sexpall) and misdisp2~= 0 and misdisp2 LT .15) sexpall=RND(meandis2).
FREQUENCIES
  VARIABLES=sexpall 
  /ORDER  ANALYSIS .

if (schmis~=169 and missing(sexpall) and misdisp2 GE .15 and misregp2~= 0 and misregp2 LT .15) sexpall=RND(meanreg2).
FREQUENCIES
  VARIABLES=sexpall 
  /ORDER  ANALYSIS .

if (schmis~=169 and missing(sexpall) and misdisp2 GE .15 and misregp2 GE .15 and misconp2~= 0 and misconp2 LT .15) sexpall=RND(meancon2).
FREQUENCIES
  VARIABLES=sexpall 
  /ORDER  ANALYSIS .

if (schmis~=169 and missing(sexpall) and misdisp2 GE .15 and misregp2 GE .15 and misconp2 GE .15) sexpall=sexpall.
FREQUENCIES
  VARIABLES=sexpall 
  /ORDER  ANALYSIS .

if (schmis~=169 and missing(sexpall)) sexpall=1.
FREQUENCIES
  VARIABLES=sexpall 
  /ORDER  ANALYSIS .

***** Automatic Cleaning by Cross-checking *****.

if schmis~=169 and sexpthis>sexpall sexpall=sexpthis.

***** Saving imputed variable *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\SQ09_10.sav' /keep country stratum idpupil sexpthis sexpall.

***** Table 11.13 Mean School Head's teaching minutes per week by Strata *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=sexpthis sexpall BY stratum
  /CELLS MEAN COUNT STDDEV  .
