GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

count schmis=ssex to sprobcom (missing).

FILTER OFF.
USE ALL.
SELECT IF(schmis~=169).
EXECUTE .

***** Aggregating at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /misdis= NMISS(slocat)   
  /numdis=N (idpupil)
  /opt_1dis = PIN(slocat 1 1)
  /opt_2dis = PIN(slocat 2 2)
  /opt_3dis = PIN(slocat 3 3)
  /opt_4dis = PIN(slocat 4 4)
 
.

***** Aggregating at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /misreg= NMISS(slocat)   
  /numreg=N (idpupil)
  /opt_1reg = PIN(slocat 1 1)
  /opt_2reg = PIN(slocat 2 2)
  /opt_3reg = PIN(slocat 3 3)
  /opt_4reg = PIN(slocat 4 4)
.

***** Aggregating at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /miscon= NMISS(slocat)  
  /numcon=N (idpupil)
  /opt_1con = PIN(slocat 1 1)
  /opt_2con = PIN(slocat 2 2)
  /opt_3con = PIN(slocat 3 3)
  /opt_4con = PIN(slocat 4 4)
.

***** Merging back the different aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

count schmis=ssex to sprobcom (missing).

FILTER OFF.
USE ALL.
SELECT IF(schmis~=169).
EXECUTE .

FREQUENCIES
  VARIABLES=slocat
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

compute misdisp= misdis/numdis.
compute misregp= misreg/numreg.
compute misconp= miscon/numcon.
EXECUTE .

***** Finding the Mode at each level *****.

if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis)=opt_4dis modedis=4.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis)=opt_3dis modedis=3.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis)=opt_2dis modedis=2.
if max(opt_1dis, opt_2dis, opt_3dis, opt_4dis)=opt_1dis modedis=1.

if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg)=opt_4reg modereg=4.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg)=opt_3reg modereg=3.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg)=opt_2reg modereg=2.
if max(opt_1reg, opt_2reg, opt_3reg, opt_4reg)=opt_1reg modereg=1.

if max(opt_1con, opt_2con, opt_3con, opt_4con)=opt_4con modecon=4.
if max(opt_1con, opt_2con, opt_3con, opt_4con)=opt_3con modecon=3.
if max(opt_1con, opt_2con, opt_3con, opt_4con)=opt_2con modecon=2.
if max(opt_1con, opt_2con, opt_3con, opt_4con)=opt_1con modecon=1.

***** Imputation at district level *****.

if (schmis~=169 and missing(slocat) and misdisp~= 0 and misdisp LT .15) slocat=modedis.

FREQUENCIES
  VARIABLES=slocat
  /ORDER  ANALYSIS .

***** Imputation at region level *****.

if (schmis~=169 and missing(slocat) and misdisp GE .15 and misregp~= 0 and misregp LT .15) slocat=modereg.

FREQUENCIES
  VARIABLES=slocat
  /ORDER  ANALYSIS .

***** Imputation at country level *****.

if (schmis~=169 and missing(slocat) and misdisp GE .15 and misregp GE .15 and misconp~= 0 and misconp LT .15) slocat=modecon.

FREQUENCIES
  VARIABLES=slocat
  /ORDER  ANALYSIS .

***** No imputation of xqacad if more than 15% missing at country level *****.

if (schmis~=169 and missing(slocat) and misdisp GE .15 and misregp GE .15 and misconp GE .15) slocat=slocat.

FREQUENCIES
  VARIABLES=slocat
  /ORDER  ANALYSIS .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating derived variable *****.

recode slocat (1 thru 2 = 0) (3 thru 4= 1) into zsloc.
recode slocat (1 thru 2 = 1) (3=2) (4=3) into zslocati.


***** saving imputed and derived variables *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\SQ14.sav' /keep country stratum idpupil slocat zsloc zslocati.

****Table 7.12 School location*****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

CROSSTABS
  /TABLES=stratum  BY slocat zsloc zslocati
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT .
