GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

count schmis=ssex to sprobcom (missing).

FILTER OFF.
USE ALL.
SELECT IF(schmis~=169).
EXECUTE .

******change missing to 0  *****.

RECODE  stchpm stchpf stchtm stchtf stchsm stchsf stchtot1  stchprim stchseco stchtert stchtot2 stchnott stchshor stch1yr stch2yr stch3yr stchmore stchtot3 (missing=0)  .

***** Calculating the total based on the sub figures *****.

compute stchtot1=stchpm +stchpf +stchtm +stchtf +stchsm +stchsf .
compute sum1bis=stchpm +stchpf +stchtm +stchtf .
compute stchtot2=stchprim+ stchseco+ stchtert .
compute stchtot3=stchnott +stchshor +stch1yr +stch2yr+ stch3yr+ stchmore .
formats sum1bis (f3.0).

***** IMPUTATION Step 0: If there is no data at all use the mos x 6 /20 *****.

DO IF sum1bis=0 and stchtot2=0 and stchtot3=0.
  compute stchtot1= RND(mos*6/20).
  compute sum1bis= RND(mos*6/20).
  compute stchtot2= RND(mos*6/20).
  compute stchtot3= RND(mos*6/20).
END IF.

***** IMPUTATION Step 1: If only one variable is valid *****.

DO IF sum1bis=0 and stchtot2=0 and stchtot3~=0.
  compute stchpm =RND(stchtot3/2).
  compute stchpf =stchtot3-stchpm.
  recode stchtm stchtf stchsm stchsf (else=0).
  compute stchtot1=stchpm +stchpf +stchtm +stchtf +stchsm +stchsf .
  compute sum1bis=stchpm +stchpf +stchtm +stchtf .
  compute stchseco=stchtot3.
  recode stchprim stchtert (else=0).
  compute stchtot2=stchprim+ stchseco+ stchtert .
END IF.

DO IF stchtot2=0 and stchtot3=0 and sum1bis~=0.
  compute stchseco=sum1bis.
  recode stchprim stchtert (else=0).
  compute stchtot2=stchprim+ stchseco+ stchtert .
  compute stch1yr=sum1bis.
  recode stchnott stchshor  stch2yr stch3yr stchmore (else=0).
  compute stchtot3=stchnott +stchshor +stch1yr +stch2yr+ stch3yr+ stchmore .
END IF.

DO IF stchtot3=0 and sum1bis=0 and stchtot2~=0.
  compute stch1yr=stchtot2.
  recode stchnott stchshor  stch2yr stch3yr stchmore (else=0).
  compute stchtot3=stchnott +stchshor +stch1yr +stch2yr+ stch3yr+ stchmore .
  compute stchpm =RND(stchtot2/2).
  compute stchpf =stchtot2-stchpm.
  recode stchtm stchtf stchsm stchsf (else=0).
  compute stchtot1=stchpm +stchpf +stchtm +stchtf +stchsm +stchsf .
  compute sum1bis=stchpm +stchpf +stchtm +stchtf .
END IF.

***** IMPUTATION Step 3: If two variables are valid and equal *****.

DO IF sum1bis=0 and stchtot2=stchtot3.
  compute stchpm =RND(stchtot2/2).
  compute stchpf =stchtot2-stchpm.
  compute stchtot1=stchpm +stchpf +stchtm +stchtf +stchsm +stchsf .
  compute sum1bis=stchpm +stchpf +stchtm +stchtf .
END IF.

DO IF stchtot2=0 and stchtot3=sum1bis.
  compute stchseco =stchtot3.
  compute stchtot2=stchprim+ stchseco+ stchtert .
END IF.

DO IF stchtot3=0 and sum1bis=stchtot2.
  compute stch1yr=sum1bis.
  compute stchtot3=stchnott +stchshor +stch1yr +stch2yr+ stch3yr+ stchmore .
END IF.

***** Automatic Cleaning Step 1: Democracy *****.

DO IF sum1bis=stchtot2 and stchtot2~=stchtot3 .
  compute    stchtot3=sum1bis.
END IF.

DO IF  stchtot2=stchtot3 and stchtot3~=sum1bis .
  compute    sum1bis=stchtot2.
END IF.

DO IF   stchtot3=sum1bis and sum1bis~=stchtot2 .
  compute  stchtot2=stchtot3.
END IF.

***** Automatic Cleaning Step 2: Using minimum differences *****.

compute diff1=abs(sum1bis-stchtot2).
compute diff2=abs(stchtot2-stchtot3).
compute diff3=abs(stchtot3-sum1bis).

DO IF min(diff1,diff2,diff3)=diff1 and sum1bis~=0 and stchtot2~=0.
  compute mid=RND(mean(sum1bis,stchtot2)).
  compute sum1bis=mid.
  compute stchtot2=mid.
  compute stchtot3=mid.
END IF.

DO IF min(diff1,diff2,diff3)=diff2 and stchtot2~=0 and stchtot3~=0.
  compute mid=RND(mean(stchtot2,stchtot3)).
  compute sum1bis=mid.
  compute stchtot2=mid.
  compute stchtot3=mid.
END IF.

DO IF min(diff1,diff2,diff3)=diff3 and stchtot3~=0 and sum1bis~=0.
  compute mid=RND(mean(stchtot3,sum1bis)).
  compute sum1bis=mid.
  compute stchtot2=mid.
  compute stchtot3=mid.
END IF.

***** Automatic Cleaning for the sub information: apply ratios*****.

DO IF stchpm +stchpf +stchtm+ stchtf ~=sum1bis and stchpm +stchpf +stchtm+ stchtf ~=0.
  compute sub14=trunc(sum1bis *stchtf/(stchpm +stchpf +stchtm+ stchtf )).
  compute sub13=trunc(sum1bis *stchtm/(stchpm +stchpf +stchtm+ stchtf )).
  compute sub12=trunc(sum1bis *stchpf/(stchpm +stchpf +stchtm+ stchtf )).
  compute sub11=sum1bis-sub14-sub13-sub12.
  compute stchpm=sub11.
  compute stchpf=sub12.
  compute stchtm=sub13.
  compute stchtf=sub14.
END IF.

DO IF stchpm +stchpf +stchtm+ stchtf ~=sum1bis and stchpm +stchpf +stchtm+ stchtf =0.
 compute stchpm=RND(sum1bis/2).
 compute stchpf=sum1bis-stchpm.
END IF.

DO IF stchprim+ stchseco +stchtert  ~= stchtot2 and stchprim+ stchseco +stchtert  ~=0.
  compute sub23=trunc(stchtot2 *stchtert/(stchprim+ stchseco +stchtert  )).
  compute sub22=trunc(stchtot2 *stchseco/(stchprim+ stchseco +stchtert  )).
  compute sub21=stchtot2-sub23-sub22.
  compute stchprim=sub21.
  compute stchseco=sub22.
  compute stchtert=sub23.
END IF.

DO IF stchprim+ stchseco +stchtert  ~= stchtot2 and stchprim+ stchseco +stchtert  =0.
  compute stchseco=stchtot2.  
END IF.

DO IF stchnott+ stchshor +stch1yr +stch2yr+ stch3yr +stchmore  ~=stchtot3 and stchnott+ stchshor +stch1yr +stch2yr+ stch3yr +stchmore  ~=0.
  compute sub36=trunc(stchtot3 *stchmore/(stchnott+ stchshor +stch1yr +stch2yr+ stch3yr +stchmore  )).
  compute sub35=trunc(stchtot3 *stch3yr/(stchnott+ stchshor +stch1yr +stch2yr+ stch3yr +stchmore  )).
  compute sub34=trunc(stchtot3 *stch2yr/(stchnott+ stchshor +stch1yr +stch2yr+ stch3yr +stchmore  )).
  compute sub33=trunc(stchtot3 *stch1yr/(stchnott+ stchshor +stch1yr +stch2yr+ stch3yr +stchmore ) ).
  compute sub32=trunc(stchtot3 *stchshor/(stchnott+ stchshor +stch1yr +stch2yr+ stch3yr +stchmore  )).
  compute sub31=stchtot3-sub31-sub32-sub33-sub34-sub35.
  compute stchnott=sub31.
  compute stchshor=sub32.
  compute stch1yr=sub33.
  compute stch2yr=sub34.
  compute stch3yr=sub35.
  compute stchmore=sub36.
END IF.

DO IF stchnott+ stchshor +stch1yr +stch2yr+ stch3yr +stchmore  ~=stchtot3 and stchnott+ stchshor +stch1yr +stch2yr+ stch3yr +stchmore  =0.
  compute stch1yr=stchtot3.
END IF.

compute stchtot1=stchpm +stchpf +stchtm +stchtf +stchsm +stchsf .
compute sum1bis=stchpm +stchpf +stchtm +stchtf .
compute stchtot2=stchprim+ stchseco+ stchtert .
compute stchtot3=stchnott +stchshor +stch1yr +stch2yr+ stch3yr+ stchmore .

*****creating and saving imputed variables *****.

sort cases by country (a) stratum (a) idpupil (a).

MATCH FILES /FILE=*
 /FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\SQ18_19_20_21_22_sfenrol_bigshift.sav'
 /RENAME (spupboy spupgirl ssess1p ssess2p ssess3p ssess4p ssess5p ssess6p sfenrol 
ssess1c  ssess2c ssess3c ssess4c ssess5c ssess6c sclass  sclass6 sfclag6 
  pfshift sfsess = d0 d1 d2 d3 d4 d5 d6 d7 d8 d9 d10 d11 d12 d13 d14 d15 d16 d17 d18 d19 )
 /BY country stratum idpupil.
EXECUTE.

compute spupboy=d0.
compute  spupgirl =d1.
compute ssess1p =d2.
compute ssess2p=d3.
compute  ssess3p =d4.
compute ssess4p =d5.
compute ssess5p=d6.
compute  ssess6p =d7.
compute sfenrol =d8.
compute ssess1c=d9.
compute   ssess2c=d10.
compute  ssess3c=d11.
 compute ssess4c=d12.
 compute ssess5c =d13.
compute ssess6c =d14.
compute sclass  =d15.
compute sclass6 =d16.
compute sfclag6 =d17.
 compute  pfshift =d18.
compute sfsess=d19.

compute zsptrati=sfenrol/stchtot1.
compute zstchaca=stchtert/stchtot2.
compute ZSTCHYR= ((0.5*STCHSHOR) + (1*STCH1YR) + (2*STCH2YR) + (3*STCH3YR) + (4*STCHMORE)) / STCHTOT3.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\SQ15_16_17.sav' /keep country stratum idpupil
 stchpm stchpf stchtm stchtf stchsm stchsf stchtot1
 stchprim stchseco stchtert stchtot2
 stchnott stchshor stch1yr stch2yr stch3yr stchmore stchtot3  zsptrati zstchaca ZSTCHYR.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

FREQUENCIES
  VARIABLES=stchtot1 stchtot2 stchtot3   /FORMAT=NOTABLE
  /STATISTICS=MINIMUM MAXIMUM MEAN MODE
  /ORDER=  ANALYSIS .

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\SQ15_16_17.sav' .
EXECUTE .

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

FREQUENCIES
  VARIABLES=stchtot1 stchtot2 stchtot3 zsptrati  /FORMAT=NOTABLE
  /STATISTICS=MINIMUM MAXIMUM MEAN MODE
  /ORDER=  ANALYSIS .

