GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

count schmis=ssex to sprobcom (missing).

FILTER OFF.
USE ALL.
SELECT IF(schmis~=169).
EXECUTE .

***** Aggregating at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /misdis= NMISS(sacthd04)   
  /numdis=N (idpupil)
  /opt_1dis = PIN(sacthd04 1 1)
  /opt_2dis = PIN(sacthd04 2 2)
  /opt_3dis = PIN(sacthd04 3 3)
.

***** Aggregating at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /misreg= NMISS(sacthd04)   
  /numreg=N (idpupil)
  /opt_1reg = PIN(sacthd04 1 1)
  /opt_2reg = PIN(sacthd04 2 2)
  /opt_3reg = PIN(sacthd04 3 3)
 .

***** Aggregating at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /miscon= NMISS(sacthd04)  
  /numcon=N (idpupil)
  /opt_1con = PIN(sacthd04 1 1)
  /opt_2con = PIN(sacthd04 2 2)
  /opt_3con = PIN(sacthd04 3 3)
  
.

***** Merging back the different aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

count schmis=ssex to sprobcom (missing).

FILTER OFF.
USE ALL.
SELECT IF(schmis~=169).
EXECUTE .

FREQUENCIES
  VARIABLES=sacthd04
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

compute misdisp= misdis/numdis.
compute misregp= misreg/numreg.
compute misconp= miscon/numcon.
EXECUTE .

***** Finding the Mode at each level *****.

if max(opt_1dis, opt_2dis, opt_3dis)=opt_3dis modedis=3.
if max(opt_1dis, opt_2dis, opt_3dis)=opt_2dis modedis=2.
if max(opt_1dis, opt_2dis, opt_3dis)=opt_1dis modedis=1.

if max(opt_1reg, opt_2reg, opt_3reg)=opt_3reg modereg=3.
if max(opt_1reg, opt_2reg, opt_3reg)=opt_2reg modereg=2.
if max(opt_1reg, opt_2reg, opt_3reg)=opt_1reg modereg=1.

if max(opt_1con, opt_2con, opt_3con)=opt_3con modecon=3.
if max(opt_1con, opt_2con, opt_3con)=opt_2con modecon=2.
if max(opt_1con, opt_2con, opt_3con)=opt_1con modecon=1.

***** Imputation at district level *****.

if (schmis~=169 and missing(sacthd04) and misdisp~= 0 and misdisp LT .15) sacthd04=modedis.

FREQUENCIES
  VARIABLES=sacthd04
  /ORDER  ANALYSIS .

***** Imputation at region level *****.

if (schmis~=169 and missing(sacthd04) and misdisp GE .15 and misregp~= 0 and misregp LT .15) sacthd04=modereg.

FREQUENCIES
  VARIABLES=sacthd04
  /ORDER  ANALYSIS .

***** Imputation at country level *****.

if (schmis~=169 and missing(sacthd04) and misdisp GE .15 and misregp GE .15 and misconp~= 0 and misconp LT .15) sacthd04=modecon.

FREQUENCIES
  VARIABLES=sacthd04
  /ORDER  ANALYSIS .

***** No imputation of xqacad if more than 15% missing at country level *****.

if (schmis~=169 and missing(sacthd04) and misdisp GE .15 and misregp GE .15 and misconp GE .15) sacthd04=sacthd04.

FREQUENCIES
  VARIABLES=sacthd04
  /ORDER  ANALYSIS .

***** Automatic Cleaning using SQ29 (most important) *****.

sort cases by country (a) stratum (a) idpupil (a).

MATCH FILES /FILE=*
 /FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\SQ29.sav'
 /RENAME (SACTMOST= d0  )
 /BY country stratum idpupil.
EXECUTE.

compute SACTMOST=d0.

if SACTMOST=4 sacthd04=3.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating derived variable *****.

recode sacthd04 (1 thru 2 =0) (3=1) into zsacthd4.

***** saving imputed and derived variables *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\SQ28.4.sav' /keep country stratum idpupil sacthd04 zsacthd4.

****Table 9.4 importance of SH tasks*****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=zsacthd4 BY  stratum
  /CELLS MEAN COUNT STDDEV  .
