GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

count schmis=ssex to sprobcom (missing).

FILTER OFF.
USE ALL.
SELECT IF(schmis~=169).
EXECUTE .

***** Aggregating at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /misdis= NMISS(spuppr02)   
  /numdis=N (idpupil)
  /opt_1dis = PIN(spuppr02 1 1)
  /opt_2dis = PIN(spuppr02 2 2)
  /opt_3dis = PIN(spuppr02 3 3)
.

***** Aggregating at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /misreg= NMISS(spuppr02)   
  /numreg=N (idpupil)
  /opt_1reg = PIN(spuppr02 1 1)
  /opt_2reg = PIN(spuppr02 2 2)
  /opt_3reg = PIN(spuppr02 3 3)
 .

***** Aggregating at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /miscon= NMISS(spuppr02)  
  /numcon=N (idpupil)
  /opt_1con = PIN(spuppr02 1 1)
  /opt_2con = PIN(spuppr02 2 2)
  /opt_3con = PIN(spuppr02 3 3)
  
.

***** Merging back the different aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

count schmis=ssex to sprobcom (missing).

FILTER OFF.
USE ALL.
SELECT IF(schmis~=169).
EXECUTE .

FREQUENCIES
  VARIABLES=spuppr02
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

compute misdisp= misdis/numdis.
compute misregp= misreg/numreg.
compute misconp= miscon/numcon.
EXECUTE .

***** Finding the Mode at each level *****.

if max(opt_1dis, opt_2dis, opt_3dis)=opt_3dis modedis=3.
if max(opt_1dis, opt_2dis, opt_3dis)=opt_2dis modedis=2.
if max(opt_1dis, opt_2dis, opt_3dis)=opt_1dis modedis=1.

if max(opt_1reg, opt_2reg, opt_3reg)=opt_3reg modereg=3.
if max(opt_1reg, opt_2reg, opt_3reg)=opt_2reg modereg=2.
if max(opt_1reg, opt_2reg, opt_3reg)=opt_1reg modereg=1.

if max(opt_1con, opt_2con, opt_3con)=opt_3con modecon=3.
if max(opt_1con, opt_2con, opt_3con)=opt_2con modecon=2.
if max(opt_1con, opt_2con, opt_3con)=opt_1con modecon=1.

***** Imputation at district level *****.

if (schmis~=169 and missing(spuppr02) and misdisp~= 0 and misdisp LT .15) spuppr02=modedis.

FREQUENCIES
  VARIABLES=spuppr02
  /ORDER  ANALYSIS .

***** Imputation at region level *****.

if (schmis~=169 and missing(spuppr02) and misdisp GE .15 and misregp~= 0 and misregp LT .15) spuppr02=modereg.

FREQUENCIES
  VARIABLES=spuppr02
  /ORDER  ANALYSIS .

***** Imputation at country level *****.

if (schmis~=169 and missing(spuppr02) and misdisp GE .15 and misregp GE .15 and misconp~= 0 and misconp LT .15) spuppr02=modecon.

FREQUENCIES
  VARIABLES=spuppr02
  /ORDER  ANALYSIS .

***** No imputation of xqacad if more than 15% missing at country level *****.

if (schmis~=169 and missing(spuppr02) and misdisp GE .15 and misregp GE .15 and misconp GE .15) spuppr02=spuppr02.

FREQUENCIES
  VARIABLES=spuppr02
  /ORDER  ANALYSIS .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating derived variable *****.

recode spuppr02 (1=1) (2 thru 3 =0) into zspupp02.

***** saving imputed and derived variables *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\SQ31.02.sav' /keep country stratum idpupil spuppr02 zspupp02.

****Table 9.5 pupil behavioural problems*****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=zspupp02 BY  stratum
  /CELLS MEAN COUNT STDDEV  .
