
GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

count schmis=ssex to sprobcom (missing).

FILTER OFF.
USE ALL.
SELECT IF(schmis~=169).
EXECUTE .

FILTER OFF.
USE ALL.

recode sareaper sareatem sclrmper sclrmtem sclrmope  (missing=sysmis).

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav' /keep country stratum region district school idpupil sclrmper sclrmtem sclrmope sareaper sareatem.

**********************************************************.
***** Impute missing in SQ35 and SQ34*****.
**********************************************************.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

IF (sclrmper> 0) avclaper=sareaper/sclrmper.
IF (sclrmtem> 0) avclatem=sareatem/sclrmtem.


***** Aggregating at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
   /meandis1= MEAN(sareaper) /misdis1= NMISS(sareaper) /meandis2= MEAN(avclaper) /misdis2= NMISS(sclrmper) 
 /meandis3= MEAN(sareatem) /misdis3= NMISS(sareatem) /meandis4= MEAN(avclatem) /misdis4= NMISS(sclrmtem) 
  /numdis=N (idpupil).

***** Aggregating at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
   /meanreg1= MEAN(sareaper) /misreg1= NMISS(sareaper) /meanreg2= MEAN(avclaper) /misreg2= NMISS(sclrmper) 
 /meanreg3= MEAN(sareatem) /misreg3= NMISS(sareatem) /meanreg4= MEAN(avclatem) /misreg4= NMISS(sclrmtem) 
  /numreg=N (idpupil).

***** Aggregating at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /meancon1= MEAN(sareaper) /miscon1= NMISS(sareaper) /meancon2= MEAN(avclaper) /miscon2= NMISS(sclrmper) 
 /meancon3= MEAN(sareatem) /miscon3= NMISS(sareatem) /meancon4= MEAN(avclatem) /miscon4= NMISS(sclrmtem) 
  /numcon=N (idpupil).

***** Merging back the calculation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .


FREQUENCIES
  VARIABLES=sclrmper sareaper sclrmtem sareatem
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute msdispc1= misdis1/numdis.
compute msregpc1= misreg1/numreg.
compute msconpc1= miscon1/numcon.
compute msdispc2= misdis2/numdis.
compute msregpc2= misreg2/numreg.
compute msconpc2= miscon2/numcon.
compute msdispc3= misdis3/numdis.
compute msregpc3= misreg3/numreg.
compute msconpc3= miscon3/numcon.
compute msdispc4= misdis4/numdis.
compute msregpc4= misreg4/numreg.
compute msconpc4= miscon4/numcon.

EXECUTE .

*****impute SQ35.1*****.

if (sclrmper>0 and (missing(sareaper) or sareaper=0) and msdispc1~= 0 and msdispc1 LT .15) sareaper=RND(meandis1).
FREQUENCIES
  VARIABLES=sareaper
  /ORDER  ANALYSIS .

if (sclrmper>0 and (missing(sareaper) or sareaper=0) and msdispc1 GE .15 and msregpc1~= 0 and msregpc1 LT .15) sareaper=RND(meanreg1).
FREQUENCIES
  VARIABLES=sareaper
  /ORDER  ANALYSIS .

if (sclrmper>0 and (missing(sareaper) or sareaper=0) and msdispc1 GE .15 and msregpc1 GE .15 and msconpc1~= 0 and msconpc1 LT .15) sareaper=RND(meancon1).
FREQUENCIES
  VARIABLES=sareaper
  /ORDER  ANALYSIS .

if (sclrmper>0 and (missing(sareaper) or sareaper=0) and msdispc1 GE .15 and msregpc1 GE .15 and msconpc1 GE .15) sareaper=sareaper.
FREQUENCIES
  VARIABLES=sareaper
  /ORDER  ANALYSIS .

*****impute SQ34.1*****.

if (sareaper>0 and (missing(sclrmper) or sclrmper=0) and msdispc2~= 0 and msdispc2 LT .15) sclrmper=RND(sareaper/meandis2).
FREQUENCIES
  VARIABLES=sclrmper
  /ORDER  ANALYSIS .

if (sareaper>0 and (missing(sclrmper) or sclrmper=0) and msdispc2 GE .15 and msregpc2~= 0 and msregpc2 LT .15) sclrmper=RND(sareaper/meanreg2).
FREQUENCIES
  VARIABLES=sclrmper
  /ORDER  ANALYSIS .

if (sclrmper>0 and (missing(sclrmper) or sclrmper=0) and msdispc2 GE .15 and msregpc2 GE .15 and msconpc2~= 0 and msconpc2 LT .15) sclrmper=RND(sareaper/meancon2).
FREQUENCIES
  VARIABLES=sclrmper
  /ORDER  ANALYSIS .

if (sclrmper>0 and (missing(sclrmper) or sclrmper=0) and msdispc2 GE .15 and msregpc2 GE .15 and msconpc2 GE .15) sclrmper=sclrmper.
FREQUENCIES
  VARIABLES=sclrmper
  /ORDER  ANALYSIS .

*****impute SQ35.2*****.

if (sclrmtem>0 and (missing(sareatem) or sareatem=0) and msdispc3~= 0 and msdispc3 LT .15) sareatem=RND(meandis3).
FREQUENCIES
  VARIABLES=sareatem
  /ORDER  ANALYSIS .

if (sclrmtem>0 and (missing(sareatem) or sareatem=0) and msdispc3 GE .15 and msregpc3~= 0 and msregpc3 LT .15) sareatem=RND(meanreg3).
FREQUENCIES
  VARIABLES=sareatem
  /ORDER  ANALYSIS .

if (sclrmtem>0 and (missing(sareatem) or sareatem=0) and msdispc3 GE .15 and msregpc3 GE .15 and msconpc3~= 0 and msconpc3 LT .15) sareatem=RND(meancon3).
FREQUENCIES
  VARIABLES=sareatem
  /ORDER  ANALYSIS .

if (sclrmtem>0 and (missing(sareatem) or sareatem=0) and msdispc3 GE .15 and msregpc3 GE .15 and msconpc3 GE .15) sareatem=sareatem.

FREQUENCIES
  VARIABLES=sareatem
  /ORDER  ANALYSIS .

*****impute SQ34.2*****.

if (sareatem>0 and (missing(sclrmtem) or sclrmtem=0) and msdispc4~= 0 and msdispc4 LT .15) sclrmtem=RND(sareatem/meandis4).
FREQUENCIES
  VARIABLES=sclrmtem
  /ORDER  ANALYSIS .

if (sareatem>0 and (missing(sclrmtem) or sclrmtem=0) and msdispc4 GE .15 and msregpc4~= 0 and msregpc4 LT .15) sclrmtem=RND(sareatem/meanreg4).
FREQUENCIES
  VARIABLES=sclrmtem
  /ORDER  ANALYSIS .

if (sareatem>0 and (missing(sclrmtem) or sclrmtem=0) and msdispc4 GE .15 and msregpc4 GE .15 and msconpc4~= 0 and msconpc4 LT .15) sclrmtem=RND(sareatem/meancon4).
FREQUENCIES
  VARIABLES=sclrmtem
  /ORDER  ANALYSIS .

if (sareatem>0 and (missing(sclrmtem) or sclrmtem=0) and msdispc4 GE .15 and msregpc4 GE .15 and msconpc4 GE .15) sclrmtem=sclrmtem.
FREQUENCIES
  VARIABLES=sclrmtem
  /ORDER  ANALYSIS .

RECODE
  sclrmper sclrmtem sclrmope  (SYSMIS=0)  .
EXECUTE .


USE ALL.
COMPUTE filter_$=(sclrmper = 0 &  sareaper > 0).
VARIABLE LABEL filter_$ 'sclrmper = 0 &  sareaper > 0 (FILTER)'.
VALUE LABELS filter_$  0 'Not Selected' 1 'Selected'.
FORMAT filter_$ (f1.0).
FILTER BY filter_$.
EXECUTE .
FREQUENCIES
  VARIABLES=idpupil
  /ORDER=  ANALYSIS .

USE ALL.
COMPUTE filter_$=(sclrmtem = 0 &  sareatem > 0).
VARIABLE LABEL filter_$ 'sclrmtem = 0 &  sareatem > 0 (FILTER)'.
VALUE LABELS filter_$  0 'Not Selected' 1 'Selected'.
FORMAT filter_$ (f1.0).
FILTER BY filter_$.
EXECUTE .
FREQUENCIES
  VARIABLES=idpupil
  /ORDER=  ANALYSIS .

FILTER OFF.
USE ALL.

***** Inconsistency check *****.

If sclrmper + sclrmtem + sclrmope=0 sclrmope=1.
If sclrmper=0 sareaper=0.
If sclrmtem=0 sareatem=0.

Recode
sclrmope (sysmis=0) (missing=0).

FREQUENCIES
  VARIABLES=sclrmper sareaper sclrmtem sareatem
  /ORDER  ANALYSIS .

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav' /.


*****Derived variable*****.

MATCH FILES /FILE=*
 /FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\SQ18_19_20_21_22_sfenrol_bigshift.sav'
 /BY country stratum idpupil.
EXECUTE.

Compute zsspace=(sareaper+sareatem)/bigshift.
execute.

FREQUENCIES
  VARIABLES=zsspace
  /ORDER  ANALYSIS .

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\SQ34_35.sav' keep country stratum idpupil sclrmper sclrmtem sclrmope sareaper sareatem zsspace.


***** Table 11.19 Classroom Space****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=zsspace BY  stratum
  /CELLS MEAN COUNT STDDEV  .
