***** Imputation for SQ39 *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

count schmis=ssex to sprobcom (missing).

FILTER OFF.
USE ALL.
SELECT IF(schmis~=169).
EXECUTE .

***** Aggregating at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /misdis= NMISS(sborrow)   
  /numdis=N (idpupil)
  /opt_2dis = PIN(sborrow 2 2)
  /opt_3dis = PIN(sborrow 3 3)
.

***** Aggregating at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /misreg= NMISS(sborrow)   
  /numreg=N (idpupil)
  /opt_2reg = PIN(sborrow 2 2)
  /opt_3reg = PIN(sborrow 3 3)
 .

***** Aggregating at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /miscon= NMISS(sborrow)  
  /numcon=N (idpupil)
  /opt_2con = PIN(sborrow 2 2)
  /opt_3con = PIN(sborrow 3 3)
 .

***** Merging back the different aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

count schmis=ssex to sprobcom (missing).

FILTER OFF.
USE ALL.
SELECT IF(schmis~=169).
EXECUTE .

FREQUENCIES
  VARIABLES=sborrow
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

compute misdisp= misdis/numdis.
compute misregp= misreg/numreg.
compute misconp= miscon/numcon.

***** Finding the Mode at each level *****.

if max(opt_2dis, opt_3dis)=opt_3dis modedis=3.
if max(opt_2dis, opt_3dis)=opt_2dis modedis=2.

if max(opt_2reg, opt_3reg)=opt_3reg modereg=3.
if max(opt_2reg, opt_3reg)=opt_2reg modereg=2.

if max(opt_2con, opt_3con)=opt_3con modecon=3.
if max(opt_2con, opt_3con)=opt_2con modecon=2.

***** Imputation at district level *****.

if (schmis~=169 and sres01=2 and missing(sborrow) and misdisp~= 0 and misdisp LT .15) sborrow=modedis.

FREQUENCIES
  VARIABLES=sborrow
  /ORDER  ANALYSIS .

***** Imputation at region level *****.

if (schmis~=169 and sres01=2 and missing(sborrow) and misdisp GE .15 and misregp~= 0 and misregp LT .15) sborrow=modereg.

FREQUENCIES
  VARIABLES=sborrow
  /ORDER  ANALYSIS .

***** Imputation at country level *****.

if (schmis~=169 and sres01=2 and missing(sborrow) and misdisp GE .15 and misregp GE .15 and misconp~= 0 and misconp LT .15) sborrow=modecon.

FREQUENCIES
  VARIABLES=sborrow
  /ORDER  ANALYSIS .

***** No imputation of sborrow if more than 15% missing at country level *****.

if (schmis~=169 and sres01=2 and missing(sborrow) and misdisp GE .15 and misregp GE .15 and misconp GE .15) sborrow=sborrow.

FREQUENCIES
  VARIABLES=sborrow
  /ORDER  ANALYSIS .

***** Automatic Cleaning between SQ38.01 and SQ39 *****.

if schmis~=169 and sres01=1 and missing(sborrow) sborrow=1.

if schmis~=169 and missing(sres01) and sborrow=1 sres01=1.
if schmis~=169 and missing(sres01) and sborrow=2 sres01=2.
if schmis~=169 and missing(sres01) and sborrow=3 sres01=2.

DO IF schmis~=169 and missing(sres01) and missing(sborrow).
  compute sres01=1.
  compute sborrow=1.
END IF.

if sres01=1 and (sborrow=2 or sborrow=3 )sres01=2.

if sres01=2 and sborrow=1 sres01=1.

***** Imputation for the rest of SQ38*****.

DO IF schmis~=169.
  recode sres02 to sres23 (missing=1).
END IF.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

FREQUENCIES
  VARIABLES=sres01 sborrow
  /FORMAT=NOTABLE
  /STATISTICS=MINIMUM MAXIMUM
  /ORDER  ANALYSIS .

CROSSTABS
  /TABLES=sres01  BY sborrow
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT .

***** Imputation for TQ12 *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=xcres1 to xcres8 ycres1 to ycres8 
  /ORDER  ANALYSIS .

DO IF idtr~="".
  recode xcres1 to xcres8 (1=1) (2=2) (missing=1).
END IF.

FREQUENCIES
  VARIABLES=xcres1 to xcres8 
  /ORDER  ANALYSIS .

DO IF idtm~="".
  recode ycres1 to ycres8 (1=1) (2=2) (missing=1).
END IF.

FREQUENCIES
  VARIABLES=ycres1 to ycres8 
  /ORDER  ANALYSIS .

***** Automatic Cleaning between TQ10 and TQ12.6 *****.

if idtr~="" and missing(xclbooks) xclbooks=0.
if idtm~="" and missing(yclbooks) yclbooks=0.

if xclbooks>0 and xcres6=1 xcres6=2.
if xclbooks=0 and xcres6=2 xcres6=1.
if yclbooks>0 and ycres6=1 ycres6=2.
if yclbooks=0 and ycres6=2 ycres6=1.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav' .

***** Imputation for PQ20 *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=pborrow
  /ORDER  ANALYSIS .

IF (idtm~="" or idtr~="") tbook = 1 .
IF (idtm~="" or idtr~="") and (xcres6=1 and ycres6=1) tbook = 0 .

if missing(pborrow) & sborrow=1 & tbook=0 pborrow=1.
if missing(pborrow) & sborrow=1 & tbook=1 pborrow=3.
if missing(pborrow) & sborrow=2 & tbook=0 pborrow=2.
if missing(pborrow) & sborrow=2 & tbook=1 pborrow=3.
if missing(pborrow) & sborrow=3 pborrow=3.
if missing(pborrow) & sborrow=2 & missing(tbook) pborrow=2.
if missing(pborrow) & sborrow=1 & missing(tbook) pborrow=1.
if missing(pborrow) & missing(sborrow) & missing(tbook) pborrow=1.
if missing(pborrow) & missing(sborrow) & tbook=0 pborrow=1.
if missing(pborrow) & missing(sborrow) & tbook=1 pborrow=3.

FREQUENCIES
  VARIABLES=pborrow
  /ORDER  ANALYSIS .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

*****Create derived variables and save for SQ38 and SQ39*****.

RECODE
  sres01 sres02 sres03 sres04 sres05 sres06 sres07 sres08 sres09 sres10 sres11 sres12 sres13 sres14 sres15 sres16 sres17 sres18 sres19 sres20 sres21 sres22 sres23
  (1 =0)  (2=1)  INTO
  zsres01 zsres02 zsres03 zsres04 zsres05 zsres06 zsres07 zsres08 zsres09 zsres10 zsres11 zsres12 zsres13 zsres14 zsres15 zsres16 zsres17 zsres18 zsres19 zsres20 zsres21 zsres22 zsres23.
EXECUTE .

compute zsrtot22=  zsres01+ zsres02+ zsres03 +zsres04 +zsres05 +zsres06 +zsres07+ zsres08 +zsres09 +zsres10 +zsres11 +zsres12 +zsres13+ zsres14 +zsres15 +
zsres16 +zsres17 +zsres18+ zsres19+ zsres20+ zsres21+  zsres23.

RECODE
  sborrow   (1 =sysmis)  (2=0)  (3=1) INTO  zsborrow .
EXECUTE .

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\SQ38_39.sav' /keep country stratum idpupil sres01 to sres23 zsres01 to zsres23 zsrtot22 sborrow zsborrow.

*******Create derived variables and save for TQ10 & TQ12*******.

RECODE
  xcres1 xcres2 xcres3 xcres4 xcres5 xcres6 xcres7 xcres8 
  (1=0)  (2=1)  INTO  zxcres1  zxcres2 zxcres3 zxcres4 zxcres5 zxcres6 zxcres7 zxcres8.
EXECUTE .

RECODE
  ycres1 ycres2 ycres3 ycres4 ycres5 ycres6 ycres7 ycres8 
  (1=0)  (2=1)  INTO  zycres1  zycres2 zycres3 zycres4 zycres5 zycres6 zycres7 zycres8.
EXECUTE .

compute zxclres8= xcres1+xcres2+xcres3+xcres4+xcres5+xcres6+xcres7+xcres8-8.
compute zyclres8=ycres1+ ycres2+ ycres3+ ycres4+ ycres5+ ycres6+ ycres7+ ycres8-8.
compute zxclfurn=xcres1+xcres4+xcres5+xcres7+xcres8-5.
compute zyclfurn=ycres1+ycres4+ycres5+ycres7+ ycres8-5.

compute zxyclbks=(xclbooks+ yclbooks )/2.
compute zxybkpup=zxyclbks/xclsize.
sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\TQ10_12.sav' /keep country stratum idpupil  xclbooks yclbooks zxyclbks zxybkpup
   xcres1 to xcres8 ycres1 to ycres8  zxcres1 to zxcres8 zycres1 to zycres8 zxclres8 zyclres8 zxclfurn zyclfurn.

*****Create derived variables and save for PQ20*******.

RECODE
  pborrow 
  (1 =sysmis)  (2=0)  (3=1) INTO  zpborrow .
EXECUTE .

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\PQ20.sav' /keep country stratum idpupil pborrow zpborrow.

***** Table 6.1 availability of classroom resources*****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=zxcres1  zxcres2 zxcres3 zxcres4 zxcres5 zxcres6 zxcres7 zxcres8  zycres1  zycres2 zycres3 zycres4 zycres5 zycres6 zycres7 zycres8
BY stratum
  /CELLS MEAN COUNT STDDEV  .

***** Table 6.2 classroom resources index*****.
MEANS
  TABLES= zxclres8 zyclres8 BY stratum
  /CELLS MEAN COUNT STDDEV  .

***** Table 7.3*****.
MEANS
  TABLES=zsres01 zsres02 zsres03 zsres04 zsres05 zsres06 zsres07 zsres08 zsres09 zsres10 zsres11 zsres12 zsres13
zsres14 zsres15 zsres16 zsres17 zsres18 zsres19 zsres20 zsres21 zsres22 zsres23 BY  stratum
  /CELLS MEAN COUNT STDDEV  .

***** Table 11.1 borrowing (reported by School Heads)*****.
MEANS
  TABLES= zsborrow BY  stratum
  /CELLS MEAN COUNT STDDEV  .

***** Table 11.1 borrowing (reported by Pupils)*****.
MEANS
  TABLES= zpborrow BY stratum
  /CELLS MEAN COUNT STDDEV  .

***** Table 11.8 # books in class library *****.
MEANS
  TABLES= xclbooks yclbooks zxyclbks BY stratum
  /CELLS MEAN COUNT STDDEV  .
