***** READING TEACHER AGGREGATION *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

Recode xage (0 thru 7=sysmis).

FILTER OFF.
USE ALL.
SELECT IF(idtr ~= "").
EXECUTE .

***** Aggregating xage at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISx.SAV'
  /BREAK=country region district 
  /meandisx= MEAN(xage) /misdisx= NMISS(xage)
  /numdisx=N (idpupil).

***** Aggregating xage at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGx.SAV'
  /BREAK=country region 
  /meanregx= MEAN(xage) /misregx= NMISS(xage)
  /numregx=N (idpupil).

***** Aggregating xage at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONx.SAV'
  /BREAK=country 
  /meanconx= MEAN(xage) /misconx= NMISS(xage)
  /numconx=N (idpupil).

***** MATH TEACHER AGGREGATION *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

Recode yage (0 =sysmis).

FILTER OFF.
USE ALL.
SELECT IF(idtm ~= "").
EXECUTE .

***** Aggregating yage at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISy.SAV'
  /BREAK=country region district 
  /meandisy= MEAN(yage) /misdisy= NMISS(yage)
  /numdisy=N (idpupil).

***** Aggregating yage at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGy.SAV'
  /BREAK=country region 
  /meanregy= MEAN(yage) /misregy= NMISS(yage)
  /numregy=N (idpupil).

***** Aggregating yage at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONy.SAV'
  /BREAK=country 
  /meancony= MEAN(yage) /miscony= NMISS(yage)
  /numcony=N (idpupil).

***** Merging back the calculation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

Recode xage (0 thru 7=sysmis).
Recode yage (0 =sysmis).

FREQUENCIES
  VARIABLES=xage yage 
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISx.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGx.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONx.sav'
 /BY country .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISy.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGy.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONy.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misdispx= misdisx/numdisx.
compute misregpx= misregx/numregx.
compute misconpx= misconx/numconx.

compute misdispy= misdisy/numdisy.
compute misregpy= misregy/numregy.
compute misconpy= miscony/numcony.

EXECUTE .

***** Reading Teachers *****.

if (idtr~= "" and missing(xage) and misdispx~= 0 and misdispx LT .15) xage=RND(meandisx).
FREQUENCIES
  VARIABLES=xage
  /ORDER  ANALYSIS .

if (idtr~= "" and missing(xage) and misdispx GE .15 and misregpx~= 0 and misregpx LT .15) xage=RND(meanregx).
FREQUENCIES
  VARIABLES=xage
  /ORDER  ANALYSIS .

if (idtr~= "" and missing(xage) and misdispx GE .15 and misregpx GE .15 and misconpx~= 0 and misconpx LT .15) xage=RND(meanconx).
FREQUENCIES
  VARIABLES=xage
  /ORDER  ANALYSIS .

if (idtr~= "" and missing(xage) and misdispx GE .15 and misregpx GE .15 and misconpx GE .15) xage=xage.
FREQUENCIES
  VARIABLES=xage
  /ORDER  ANALYSIS .

***** Math Teachers *****.

if (idtm~= "" and missing(yage) and misdispy~= 0 and misdispy LT .15) yage=RND(meandisy).
FREQUENCIES
  VARIABLES=yage
  /ORDER  ANALYSIS .

if (idtm~= "" and missing(yage) and misdispy GE .15 and misregpy~= 0 and misregpy LT .15) yage=RND(meanregy).
FREQUENCIES
  VARIABLES=yage
  /ORDER  ANALYSIS .

if (idtm~= "" and missing(yage) and misdispy GE .15 and misregpy GE .15 and misconpy~= 0 and misconpy LT .15) yage=RND(meancony).
FREQUENCIES
  VARIABLES=yage
  /ORDER  ANALYSIS .

if (idtm~= "" and missing(yage) and misdispy GE .15 and misregpy GE .15 and misconpy GE .15) yage=yage.
FREQUENCIES
  VARIABLES=yage
  /ORDER  ANALYSIS .

FREQUENCIES
  VARIABLES=xage yage  /FORMAT=NOTABLE
  /ORDER  ANALYSIS .

***** Checking if the same teacher was imputed with different values *****.

USE ALL.
COMPUTE filter_$=(idtr=idtm and xage~=yage).
VARIABLE LABEL filter_$ 'idtr=idtm and xage~=yage  (FILTER)'.
VALUE LABELS filter_$  0 'Not Selected' 1 'Selected'.
FORMAT filter_$ (f1.0).
FILTER BY filter_$.
EXECUTE .

SUMMARIZE
  /TABLES=country region district idpupil idtr xage idtm yage
  /FORMAT=VALIDLIST NOCASENUM TOTAL
  /TITLE='same teacher but differently imputed'
  /MISSING=VARIABLE
  /CELLS=COUNT .

FILTER OFF.
USE ALL.
EXECUTE .

if idtr~= "" and idtm~= "" and idtr=idtm and xage~=yage yage=xage.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating derived variables *****.

RECODE
  xage yage
  (Lowest thru 19=19)  (20 thru 24=22)  (25 thru 29=27)  (30 thru 34=32)  (35
  thru 39=37)  (40 thru 44=42)  (45 thru 49=47)  (50 thru 97=55)  INTO
  zxagelvl zyagelvl .
EXECUTE .

***** Saving imputed and derived variables *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\TQ03.sav' /keep country stratum idpupil xage yage zxagelvl zyagelvl .

***** Table4.1 (B) Mean teacher age by Strata *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=zxagelvl zyagelvl BY stratum
  /CELLS MEAN COUNT STDDEV  .


