***** READING TEACHER AGGREGATION *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FILTER OFF.
USE ALL.
SELECT IF(idtr ~= "").
EXECUTE .

***** Aggregating xexper at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISx.SAV'
  /BREAK=country region district 
  /meandisx= MEAN(xexper) /misdisx= NMISS(xexper)
  /numdisx=N (idpupil).

***** Aggregating xexper at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGx.SAV'
  /BREAK=country region 
  /meanregx= MEAN(xexper) /misregx= NMISS(xexper)
  /numregx=N (idpupil).

***** Aggregating xexper at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONx.SAV'
  /BREAK=country 
  /meanconx= MEAN(xexper) /misconx= NMISS(xexper)
  /numconx=N (idpupil).

***** MATH TEACHER AGGREGATION *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FILTER OFF.
USE ALL.
SELECT IF(idtm ~= "").
EXECUTE .

***** Aggregating yexper at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISy.SAV'
  /BREAK=country region district 
  /meandisy= MEAN(yexper) /misdisy= NMISS(yexper)
  /numdisy=N (idpupil).

***** Aggregating yexper at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGy.SAV'
  /BREAK=country region 
  /meanregy= MEAN(yexper) /misregy= NMISS(yexper)
  /numregy=N (idpupil).

***** Aggregating yexper at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONy.SAV'
  /BREAK=country 
  /meancony= MEAN(yexper) /miscony= NMISS(yexper)
  /numcony=N (idpupil).

***** Merging back the calculation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=xexper yexper
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISx.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGx.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONx.sav'
 /BY country .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISy.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGy.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONy.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misdispx= misdisx/numdisx.
compute misregpx= misregx/numregx.
compute misconpx= misconx/numconx.

compute misdispy= misdisy/numdisy.
compute misregpy= misregy/numregy.
compute misconpy= miscony/numcony.

EXECUTE .

***** Reading Teachers *****.

if (idtr~= "" and missing(xexper) and misdispx~= 0 and misdispx LT .15) xexper=RND(meandisx).
FREQUENCIES
  VARIABLES=xexper
  /ORDER  ANALYSIS .

if (idtr~= "" and missing(xexper) and misdispx GE .15 and misregpx~= 0 and misregpx LT .15) xexper=RND(meanregx).
FREQUENCIES
  VARIABLES=xexper
  /ORDER  ANALYSIS .

if (idtr~= "" and missing(xexper) and misdispx GE .15 and misregpx GE .15 and misconpx~= 0 and misconpx LT .15) xexper=RND(meanconx).
FREQUENCIES
  VARIABLES=xexper
  /ORDER  ANALYSIS .

if (idtr~= "" and missing(xexper) and misdispx GE .15 and misregpx GE .15 and misconpx GE .15) xexper=xexper.
FREQUENCIES
  VARIABLES=xexper
  /ORDER  ANALYSIS .

***** Math Teachers *****.

if (idtm~= "" and missing(yexper) and misdispy~= 0 and misdispy LT .15) yexper=RND(meandisy).
FREQUENCIES
  VARIABLES=yexper
  /ORDER  ANALYSIS .

if (idtm~= "" and missing(yexper) and misdispy GE .15 and misregpy~= 0 and misregpy LT .15) yexper=RND(meanregy).
FREQUENCIES
  VARIABLES=yexper
  /ORDER  ANALYSIS .

if (idtm~= "" and missing(yexper) and misdispy GE .15 and misregpy GE .15 and misconpy~= 0 and misconpy LT .15) yexper=RND(meancony).
FREQUENCIES
  VARIABLES=yexper
  /ORDER  ANALYSIS .

if (idtm~= "" and missing(yexper) and misdispy GE .15 and misregpy GE .15 and misconpy GE .15) yexper=yexper.
FREQUENCIES
  VARIABLES=yexper
  /ORDER  ANALYSIS .

FREQUENCIES
  VARIABLES=xexper yexper/FORMAT=NOTABLE
  /ORDER  ANALYSIS .

USE ALL.
COMPUTE filter_$=(idtr=idtm and xinservd~=yinservd ).
VARIABLE LABEL filter_$ 'idtr=idtm and xinservd~=yinservd  (FILTER)'.
VALUE LABELS filter_$  0 'Not Selected' 1 'Selected'.
FORMAT filter_$ (f1.0).
FILTER BY filter_$.
EXECUTE .

SUMMARIZE
  /TABLES=country region district idpupil idtr xinservd idtm yinservd
  /FORMAT=VALIDLIST NOCASENUM TOTAL
  /TITLE='same teacher but differently imputed'
  /MISSING=VARIABLE
  /CELLS=COUNT .

FILTER OFF.
USE ALL.
EXECUTE .

***** Checking if the same teacher was imputed with different values *****.

USE ALL.
COMPUTE filter_$=(idtr=idtm and xexper~=yexper).
VARIABLE LABEL filter_$ 'idtr=idtm and xexper~=yexper  (FILTER)'.
VALUE LABELS filter_$  0 'Not Selected' 1 'Selected'.
FORMAT filter_$ (f1.0).
FILTER BY filter_$.
EXECUTE .

SUMMARIZE
  /TABLES=country region district idpupil idtr xexper idtm yexper
  /FORMAT=VALIDLIST NOCASENUM TOTAL
  /TITLE='same teacher but differently imputed'
  /MISSING=VARIABLE
  /CELLS=COUNT .

FILTER OFF.
USE ALL.
EXECUTE .

if idtr~= "" and idtm~= "" and idtr=idtm and xexper~=yexper yexper=xexper.

Recode xexper yexper (0=1) (else=copy).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Saving imputed and derived variables *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\TQ06.sav' /keep country stratum idpupil xexper yexper.

***** Table4.2 (B) Mean teacher experience by Strata *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=xexper yexper BY stratum
  /CELLS MEAN COUNT STDDEV  .
