***** READING TEACHER AGGREGATION *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

recode Xperiods Xminutes (0=sysmis) (else=copy).

FILTER OFF.
USE ALL.
SELECT IF(idtr ~= "").
EXECUTE .

***** Aggregating Xperiods and Xminutes at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISx.SAV'
  /BREAK=country region district 
  /meandisx= MEAN(Xperiods) /misdisx= NMISS(Xperiods)
  /mndisx0= MEAN(Xminutes) /misdisx0= NMISS(Xminutes)
  /numdisx=N (idpupil).

***** Aggregating Xperiods and Xminutes at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGx.SAV'
  /BREAK=country region 
  /meanregx= MEAN(Xperiods) /misregx= NMISS(Xperiods)
  /mnregx0= MEAN(Xminutes) /misregx0= NMISS(Xminutes)
  /numregx=N (idpupil).

***** Aggregating Xperiods and Xminutes at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONx.SAV'
  /BREAK=country 
  /meanconx= MEAN(Xperiods) /misconx= NMISS(Xperiods)
  /mnconx0= MEAN(Xminutes) /misconx0= NMISS(Xminutes)
  /numconx=N (idpupil).

***** MATH TEACHER AGGREGATION *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

recode Yperiods Yminutes (0=sysmis) (else=copy).

FILTER OFF.
USE ALL.
SELECT IF(idtm ~= "").
EXECUTE .

***** Aggregating Yperiods and Yminutes at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISy.SAV'
  /BREAK=country region district 
  /meandisy= MEAN(Yperiods) /misdisy= NMISS(Yperiods)
  /mndisy0= MEAN(Yminutes) /misdisy0= NMISS(Yminutes)
  /numdisy=N (idpupil).

***** Aggregating Yperiods and Yminutes at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGy.SAV'
  /BREAK=country region 
  /meanregy= MEAN(Yperiods) /misregy= NMISS(Yperiods)
  /mnregy0= MEAN(Yminutes) /misregy0= NMISS(Yminutes)
  /numregy=N (idpupil).

***** Aggregating Yperiods and Yminutes at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONy.SAV'
  /BREAK=country 
  /meancony= MEAN(Yperiods) /miscony= NMISS(Yperiods)
  /mncony0= MEAN(Yminutes) /miscony0= NMISS(Yminutes)
  /numcony=N (idpupil).

***** Merging back the calculation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

recode Xperiods Xminutes Yperiods Yminutes (0=sysmis) (else=copy).

FREQUENCIES
  VARIABLES=Xperiods Xminutes Yperiods Yminutes 
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISx.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGx.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONx.sav'
 /BY country .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISy.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGy.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONy.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misdispx= misdisx/numdisx.
compute misregpx= misregx/numregx.
compute misconpx= misconx/numconx.

compute misdispy= misdisy/numdisy.
compute misregpy= misregy/numregy.
compute misconpy= miscony/numcony.

compute msdispx0= misdisx0/numdisx.
compute msregpx0= misregx0/numregx.
compute msconpx0= misconx0/numconx.

compute msdispy0= misdisy0/numdisy.
compute msregpy0= misregy0/numregy.
compute msconpy0= miscony0/numcony.

EXECUTE .

***** Reading Teachers Xperiod*****.

if (idtr~= "" and missing(Xperiods) and misdispx~= 0 and misdispx LT .15) Xperiods=RND(meandisx).
FREQUENCIES
  VARIABLES=Xperiods
  /ORDER  ANALYSIS .

if (idtr~= "" and missing(Xperiods) and misdispx GE .15 and misregpx~= 0 and misregpx LT .15) Xperiods=RND(meanregx).
FREQUENCIES
  VARIABLES=Xperiods
  /ORDER  ANALYSIS .

if (idtr~= "" and missing(Xperiods) and misdispx GE .15 and misregpx GE .15 and misconpx~= 0 and misconpx LT .15) Xperiods=RND(meanconx).
FREQUENCIES
  VARIABLES=Xperiods
  /ORDER  ANALYSIS .

if (idtr~= "" and missing(Xperiods) and misdispx GE .15 and misregpx GE .15 and misconpx GE .15) Xperiods=Xperiods.
FREQUENCIES
  VARIABLES=Xperiods
  /ORDER  ANALYSIS .

***** Math Teachers Yperiod*****.

if (idtm~= "" and missing(Yperiods) and misdispy~= 0 and misdispy LT .15) Yperiods=RND(meandisy).
FREQUENCIES
  VARIABLES=Yperiods
  /ORDER  ANALYSIS .

if (idtm~= "" and missing(Yperiods) and misdispy GE .15 and misregpy~= 0 and misregpy LT .15) Yperiods=RND(meanregy).
FREQUENCIES
  VARIABLES=Yperiods
  /ORDER  ANALYSIS .

if (idtm~= "" and missing(Yperiods) and misdispy GE .15 and misregpy GE .15 and misconpy~= 0 and misconpy LT .15) Yperiods=RND(meancony).
FREQUENCIES
  VARIABLES=Yperiods
  /ORDER  ANALYSIS .

if (idtm~= "" and missing(Yperiods) and misdispy GE .15 and misregpy GE .15 and misconpy GE .15) Yperiods=Yperiods.
FREQUENCIES
  VARIABLES=Yperiods
  /ORDER  ANALYSIS .

FREQUENCIES
  VARIABLES=Xperiods Yperiods  /FORMAT=NOTABLE
  /ORDER  ANALYSIS .

***** Reading Teachers Xminutes*****.

if (idtr~= "" and missing(Xminutes) and msdispx0~= 0 and msdispx0 LT .15) Xminutes=RND(mndisx0).
FREQUENCIES
  VARIABLES=Xminutes
  /ORDER  ANALYSIS .

if (idtr~= "" and missing(Xminutes) and msdispx0 GE .15 and msregpx0~= 0 and msregpx0 LT .15) Xminutes=RND(mnregx0).
FREQUENCIES
  VARIABLES=Xminutes
  /ORDER  ANALYSIS .

if (idtr~= "" and missing(Xminutes) and msdispx0 GE .15 and msregpx0 GE .15 and msconpx0~= 0 and msconpx0 LT .15) Xminutes=RND(mnconx0).
FREQUENCIES
  VARIABLES=Xminutes
  /ORDER  ANALYSIS .

if (idtr~= "" and missing(Xminutes) and msdispx0 GE .15 and msregpx0 GE .15 and msconpx0 GE .15) Xminutes=Xminutes.
FREQUENCIES
  VARIABLES=Xminutes
  /ORDER  ANALYSIS .

***** Math Teachers Yminutes*****.

if (idtm~= "" and missing(Yminutes) and msdispy0~= 0 and msdispy0 LT .15) Yminutes=RND(mndisy0).
FREQUENCIES
  VARIABLES=Yminutes
  /ORDER  ANALYSIS .

if (idtm~= "" and missing(Yminutes) and msdispy0 GE .15 and msregpy0~= 0 and msregpy0 LT .15) Yminutes=RND(mnregy0).
FREQUENCIES
  VARIABLES=Yminutes
  /ORDER  ANALYSIS .

if (idtm~= "" and missing(Yminutes) and msdispy0 GE .15 and msregpy0 GE .15 and msconpy0~= 0 and msconpy0 LT .15) Yminutes=RND(mncony0).
FREQUENCIES
  VARIABLES=Yminutes
  /ORDER  ANALYSIS .

if (idtm~= "" and missing(Yminutes) and msdispy0 GE .15 and msregpy0 GE .15 and msconpy0 GE .15) Yminutes=Yminutes.
FREQUENCIES
  VARIABLES=Yminutes
  /ORDER  ANALYSIS .

FREQUENCIES
  VARIABLES=Xminutes Yminutes  /FORMAT=NOTABLE
  /ORDER  ANALYSIS .

***** Checking if the same teacher was imputed with different values *****.

USE ALL.
COMPUTE filter_$=(idtr=idtm and Xperiods~=Yperiods).
VARIABLE LABEL filter_$ 'idtr=idtm and Xperiods~=Yperiods  (FILTER)'.
VALUE LABELS filter_$  0 'Not Selected' 1 'Selected'.
FORMAT filter_$ (f1.0).
FILTER BY filter_$.
EXECUTE .

SUMMARIZE
  /TABLES=country region district idpupil idtr Xperiods idtm Yperiods
  /FORMAT=VALIDLIST NOCASENUM TOTAL
  /TITLE='same teacher but differently imputed - PERIODS'
  /MISSING=VARIABLE
  /CELLS=COUNT .

FILTER OFF.
USE ALL.
EXECUTE .

if idtr~= "" and idtm~= "" and idtr=idtm and Xperiods~=Yperiods  Yperiods=Xperiods.

USE ALL.
COMPUTE filter_$=(idtr=idtm and Xminutes~=Yminutes).
VARIABLE LABEL filter_$ 'idtr=idtm and Xminutes~=Yminutes  (FILTER)'.
VALUE LABELS filter_$  0 'Not Selected' 1 'Selected'.
FORMAT filter_$ (f1.0).
FILTER BY filter_$.
EXECUTE .

SUMMARIZE
  /TABLES=country region district idpupil idtr Xminutes idtm Yminutes
  /FORMAT=VALIDLIST NOCASENUM TOTAL
  /TITLE='same teacher but differently imputed - MINUTES'
  /MISSING=VARIABLE
  /CELLS=COUNT .

FILTER OFF.
USE ALL.
EXECUTE .

if idtr~= "" and idtm~= "" and idtr=idtm and Xminutes~=Yminutes  Yminutes=Xminutes.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Saving imputed and derived variables *****.

if idtr~= ""  zxhrteac=xperiods*xminutes/60.
if idtm~= ""  zyhrteac=yperiods*yminutes/60.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\TQ14_15.sav' /keep country stratum idpupil Xperiods Yperiods xminutes yminutes zxhrteac zyhrteac.

***** Table 11.4 time spent on teaching *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=zxhrteac zyhrteac BY stratum
  /CELLS MEAN COUNT STDDEV  .


