*****  READING TEACHER AGGREGATION *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

DO IF xmeeusua GT 100.
  recode xmeeusua (else=sysmis).
END IF.

DO IF ymeeusua GT 100.
  recode ymeeusua (else=sysmis).
END IF.

FILTER OFF.
USE ALL.
SELECT IF(idtr ~= "").
EXECUTE .

***** Aggregating xmeetpar at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISx.SAV'
  /BREAK=country region district 
  /misdisx= NMISS(xmeetpar)   
  /numdisx=N (idpupil)
  /optx1dis = PIN(xmeetpar 1 1)
  /optx2dis = PIN(xmeetpar 2 2)
  /optx3dis = PIN(xmeetpar 3 3)
  /optx4dis = PIN(xmeetpar 4 4)
  /optx5dis = PIN(xmeetpar 5 5)
  /misdisx0=NMISS(xmeeusua)
  /mndisx0=MEAN(xmeeusua)
.

***** Aggregating xmeetpar at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGx.SAV'
  /BREAK=country region 
  /misregx= NMISS(xmeetpar)   
  /numregx=N (idpupil)
  /optx1reg = PIN(xmeetpar 1 1)
  /optx2reg = PIN(xmeetpar 2 2)
  /optx3reg = PIN(xmeetpar 3 3)
  /optx4reg = PIN(xmeetpar 4 4)
  /optx5reg = PIN(xmeetpar 5 5)
  /misregx0=NMISS(xmeeusua)
  /mnregx0=MEAN(xmeeusua)
.

***** Aggregating xmeetpar at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONx.SAV'
  /BREAK=country 
  /misconx= NMISS(xmeetpar)  
  /numconx=N (idpupil)
  /optx1con = PIN(xmeetpar 1 1)
  /optx2con = PIN(xmeetpar 2 2)
  /optx3con = PIN(xmeetpar 3 3)
  /optx4con = PIN(xmeetpar 4 4)
  /optx5con = PIN(xmeetpar 5 5)
  /misconx0=NMISS(xmeeusua)
  /mnconx0=MEAN(xmeeusua)
.

***** MATHEMATICS TEACHER AGGREGATION *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

DO IF xmeeusua GT 100.
  recode xmeeusua (else=sysmis).
END IF.

DO IF ymeeusua GT 100.
  recode ymeeusua (else=sysmis).
END IF.

FILTER OFF.
USE ALL.
SELECT IF(idtr ~= "").
EXECUTE .

FILTER OFF.
USE ALL.
SELECT IF(idtm ~= "").
EXECUTE .

***** Aggregating ymeetpar at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISy.SAV'
  /BREAK=country region district 
  /misdisy= NMISS(ymeetpar)   
  /numdisy=N (idpupil)
  /opty1dis = PIN(ymeetpar 1 1)
  /opty2dis = PIN(ymeetpar 2 2)
  /opty3dis = PIN(ymeetpar 3 3)
  /opty4dis = PIN(ymeetpar 4 4)
  /opty5dis = PIN(ymeetpar 5 5)
  /misdisy0=NMISS(ymeeusua)
  /mndisy0=MEAN(ymeeusua)
.

***** Aggregating ymeetpar at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGy.SAV'
  /BREAK=country region 
  /misregy= NMISS(ymeetpar)   
  /numregy=N (idpupil)
  /opty1reg = PIN(ymeetpar 1 1)
  /opty2reg = PIN(ymeetpar 2 2)
  /opty3reg = PIN(ymeetpar 3 3)
  /opty4reg = PIN(ymeetpar 4 4)
  /opty5reg = PIN(ymeetpar 5 5)
  /misregy0=NMISS(ymeeusua)
  /mnregy0=MEAN(ymeeusua)
.

***** Aggregating ymeetpar at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONy.SAV'
  /BREAK=country 
  /miscony= NMISS(ymeetpar)  
  /numcony=N (idpupil)
  /opty1con = PIN(ymeetpar 1 1)
  /opty2con = PIN(ymeetpar 2 2)
  /opty3con = PIN(ymeetpar 3 3)
  /opty4con = PIN(ymeetpar 4 4)
  /opty5con = PIN(ymeetpar 5 5)
  /miscony0=NMISS(ymeeusua)
  /mncony0=MEAN(ymeeusua)
.

***** Merging back the different aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

DO IF xmeeusua GT 100.
  recode xmeeusua (else=sysmis).
END IF.

DO IF ymeeusua GT 100.
  recode ymeeusua (else=sysmis).
END IF.

FREQUENCIES
  VARIABLES=xmeetpar ymeetpar
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISx.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGx.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONx.sav'
 /BY country .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISy.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGy.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONy.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misdispx= misdisx/numdisx.
compute misregpx= misregx/numregx.
compute misconpx= misconx/numconx.

compute misdispy= misdisy/numdisy.
compute misregpy= misregy/numregy.
compute misconpy= miscony/numcony.

compute msdispx0= misdisx0/numdisx.
compute msregpx0= misregx0/numregx.
compute msconpx0= misconx0/numconx.

compute msdispy0= misdisy0/numdisy.
compute msregpy0= misregy0/numregy.
compute msconpy0= miscony0/numcony.

EXECUTE .

***** Finding the Mode at each level *****.

if max(optx1dis, optx2dis, optx3dis, optx4dis, optx5dis)=optx5dis modedisx=5.
if max(optx1dis, optx2dis, optx3dis, optx4dis, optx5dis)=optx4dis modedisx=4.
if max(optx1dis, optx2dis, optx3dis, optx4dis, optx5dis)=optx3dis modedisx=3.
if max(optx1dis, optx2dis, optx3dis, optx4dis, optx5dis)=optx2dis modedisx=2.
if max(optx1dis, optx2dis, optx3dis, optx4dis, optx5dis)=optx1dis modedisx=1.

if max(optx1reg, optx2reg, optx3reg, optx4reg, optx5reg)=optx5reg moderegx=5.
if max(optx1reg, optx2reg, optx3reg, optx4reg, optx5reg)=optx4reg moderegx=4.
if max(optx1reg, optx2reg, optx3reg, optx4reg, optx5reg)=optx3reg moderegx=3.
if max(optx1reg, optx2reg, optx3reg, optx4reg, optx5reg)=optx2reg moderegx=2.
if max(optx1reg, optx2reg, optx3reg, optx4reg, optx5reg)=optx1reg moderegx=1.

if max(optx1con, optx2con, optx3con, optx4con, optx5con)=optx5con modeconx=5.
if max(optx1con, optx2con, optx3con, optx4con, optx5con)=optx4con modeconx=4.
if max(optx1con, optx2con, optx3con, optx4con, optx5con)=optx3con modeconx=3.
if max(optx1con, optx2con, optx3con, optx4con, optx5con)=optx2con modeconx=2.
if max(optx1con, optx2con, optx3con, optx4con, optx5con)=optx1con modeconx=1.

if max(opty1dis, opty2dis, opty3dis, opty4dis, opty5dis)=opty5dis modedisy=5.
if max(opty1dis, opty2dis, opty3dis, opty4dis, opty5dis)=opty4dis modedisy=4.
if max(opty1dis, opty2dis, opty3dis, opty4dis, opty5dis)=opty3dis modedisy=3.
if max(opty1dis, opty2dis, opty3dis, opty4dis, opty5dis)=opty2dis modedisy=2.
if max(opty1dis, opty2dis, opty3dis, opty4dis, opty5dis)=opty1dis modedisy=1.

if max(opty1reg, opty2reg, opty3reg, opty4reg, opty5reg)=opty5reg moderegy=5.
if max(opty1reg, opty2reg, opty3reg, opty4reg, opty5reg)=opty4reg moderegy=4.
if max(opty1reg, opty2reg, opty3reg, opty4reg, opty5reg)=opty3reg moderegy=3.
if max(opty1reg, opty2reg, opty3reg, opty4reg, opty5reg)=opty2reg moderegy=2.
if max(opty1reg, opty2reg, opty3reg, opty4reg, opty5reg)=opty1reg moderegy=1.

if max(opty1con, opty2con, opty3con, opty4con, opty5con)=opty5con modecony=5.
if max(opty1con, opty2con, opty3con, opty4con, opty5con)=opty4con modecony=4.
if max(opty1con, opty2con, opty3con, opty4con, opty5con)=opty3con modecony=3.
if max(opty1con, opty2con, opty3con, opty4con, opty5con)=opty2con modecony=2.
if max(opty1con, opty2con, opty3con, opty4con, opty5con)=opty1con modecony=1.

***** Imputation of xmeetpar at district level *****.

if (idtr~="" and missing(xmeetpar) and misdispx~= 0 and misdispx LT .15) xmeetpar=modedisx.

FREQUENCIES
  VARIABLES=xmeetpar
  /ORDER  ANALYSIS .

***** Imputation of xmeetpar at region level *****.

if (idtr~="" and missing(xmeetpar) and misdispx GE .15 and misregpx~= 0 and misregpx LT .15) xmeetpar=moderegx.

FREQUENCIES
  VARIABLES=xmeetpar
  /ORDER  ANALYSIS .

***** Imputation of xmeetpar at country level *****.

if (idtr~="" and missing(xmeetpar) and misdispx GE .15 and misregpx GE .15 and misconpx~= 0 and misconpx LT .15) xmeetpar=modeconx.

FREQUENCIES
  VARIABLES=xmeetpar
  /ORDER  ANALYSIS .

***** No imputation of xmeetpar if more than 15% missing at country level *****.

if (idtr~="" and missing(xmeetpar) and misdispx GE .15 and misregpx GE .15 and misconpx GE .15) xmeetpar=xmeetpar.
FREQUENCIES
  VARIABLES=xmeetpar
  /ORDER  ANALYSIS .

***** Imputation of ymeetpar at district level *****.

if (idtm~="" and missing(ymeetpar) and misdispy~= 0 and misdispy LT .15) ymeetpar=modedisy.

FREQUENCIES
  VARIABLES=ymeetpar
  /ORDER  ANALYSIS .

***** Imputation of ymeetpar at region level *****.

if (idtm~="" and missing(ymeetpar) and misdispy GE .15 and misregpy~= 0 and misregpy LT .15) ymeetpar=moderegy.

FREQUENCIES
  VARIABLES=ymeetpar
  /ORDER  ANALYSIS .

***** Imputation of ymeetpar at country level *****.

if (idtm~="" and missing(ymeetpar) and misdispy GE .15 and misregpy GE .15 and misconpy~= 0 and misconpy LT .15) ymeetpar=modecony.

FREQUENCIES
  VARIABLES=ymeetpar
  /ORDER  ANALYSIS .

***** No imputation of ymeetpar if more than 15% missing at country level *****.

if (idtm~="" and missing(ymeetpar) and misdispy GE .15 and misregpy GE .15 and misconpy GE .15) ymeetpar=ymeetpar.
FREQUENCIES
  VARIABLES=ymeetpar
  /ORDER  ANALYSIS .

***** Checking if the same teacher was imputed with different values *****.

USE ALL.
COMPUTE filter_$=(idtr=idtm and xmeetpar~=ymeetpar ).
VARIABLE LABEL filter_$ 'idtr=idtm and xmeetpar~=ymeetpar  (FILTER)'.
VALUE LABELS filter_$  0 'Not Selected' 1 'Selected'.
FORMAT filter_$ (f1.0).
FILTER BY filter_$.
EXECUTE .

SUMMARIZE
  /TABLES=country region district idpupil idtr xmeetpar idtm ymeetpar
  /FORMAT=VALIDLIST NOCASENUM TOTAL
  /TITLE='same teacher but differently imputed (Teacher meets parents)'
  /MISSING=VARIABLE
  /CELLS=COUNT .

FILTER OFF.
USE ALL.
EXECUTE .

if idtr~= "" and idtm~= "" and idtr=idtm and xmeetpar~=ymeetpar ymeetpar=xmeetpar.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Imputation of xmeeusua *****.

if (idtr~= "" and missing(xmeeusua) and msdispx0~= 0 and msdispx0 LT .15) xmeeusua=RND(mndisx0).
FREQUENCIES
  VARIABLES=xmeeusua
  /ORDER  ANALYSIS .

if (idtr~= "" and missing(xmeeusua) and msdispx0 GE .15 and msregpx0~= 0 and msregpx0 LT .15) xmeeusua=RND(mnregx0).
FREQUENCIES
  VARIABLES=xmeeusua
  /ORDER  ANALYSIS .

if (idtr~= "" and missing(xmeeusua) and msdispx0 GE .15 and msregpx0 GE .15 and msconpx0~= 0 and msconpx0 LT .15) xmeeusua=RND(mnconx0).
FREQUENCIES
  VARIABLES=xmeeusua
  /ORDER  ANALYSIS .

if (idtr~= "" and missing(xmeeusua) and msdispx0 GE .15 and msregpx0 GE .15 and msconpx0 GE .15) xmeeusua=xmeeusua.
FREQUENCIES
  VARIABLES=xmeeusua
  /ORDER  ANALYSIS .

***** Imputation of ymeeusua *****.

if (idtm~= "" and missing(ymeeusua) and msdispy0~= 0 and msdispy0 LT .15) ymeeusua=RND(mndisy0).
FREQUENCIES
  VARIABLES=ymeeusua
  /ORDER  ANALYSIS .

if (idtm~= "" and missing(ymeeusua) and msdispy0 GE .15 and msregpy0~= 0 and msregpy0 LT .15) ymeeusua=RND(mnregy0).
FREQUENCIES
  VARIABLES=ymeeusua
  /ORDER  ANALYSIS .

if (idtm~= "" and missing(ymeeusua) and msdispy0 GE .15 and msregpy0 GE .15 and msconpy0~= 0 and msconpy0 LT .15) ymeeusua=RND(mncony0).
FREQUENCIES
  VARIABLES=ymeeusua
  /ORDER  ANALYSIS .

if (idtm~= "" and missing(ymeeusua) and msdispy0 GE .15 and msregpy0 GE .15 and msconpy0 GE .15) ymeeusua=ymeeusua.
FREQUENCIES
  VARIABLES=ymeeusua
  /ORDER  ANALYSIS .

***** Checking if the same teacher was imputed with different values *****.

USE ALL.
COMPUTE filter_$=(idtr=idtm and xmeeusua~=ymeeusua ).
VARIABLE LABEL filter_$ 'idtr=idtm and xmeeusua~=ymeeusua   (FILTER)'.
VALUE LABELS filter_$  0 'Not Selected' 1 'Selected'.
FORMAT filter_$ (f1.0).
FILTER BY filter_$.
EXECUTE .

SUMMARIZE
  /TABLES=country region district idpupil idtr xmeeusua idtm ymeeusua
  /FORMAT=VALIDLIST NOCASENUM TOTAL
  /TITLE='same teacher but differently imputed (% parents meet usually)'
  /MISSING=VARIABLE
  /CELLS=COUNT .

FILTER OFF.
USE ALL.
EXECUTE .

if idtr~= "" and idtm~= "" and idtr=idtm and xmeeusua~=ymeeusua ymeeusua=xmeeusua.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** consistency with TQ18 *****.

if idtr~="" and xmeetpar=1  xmeeusua=0.
if idtr~="" and xmeeusua=0 xmeetpar=1  .

if idtm~="" and ymeetpar=1  ymeeusua=0.
if idtm~="" and ymeeusua=0 ymeetpar=1  .

***** saving imputed and derived variables *****.

DO IF  idtr~="" .
  RECODE xmeetpar  (1,2=0) (3,4=1) into zxmeet   .
END IF.

DO IF  idtm~="" .
  RECODE  ymeetpar (1,2=0) (3,4=1) into  zymeet  .
END IF.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\TQ17_18.sav' /keep country stratum idpupil xmeetpar xmeeusua zxmeet   ymeetpar ymeeusua zymeet.

****Table XXX Teachers meet parents*****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

CROSSTABS
  /TABLES=stratum  BY xmeetpar ymeetpar 
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT .

***** Table 11.6 Parents meet teachers *****.

MEANS
  TABLES=xmeeusua  ymeeusua
BY stratum
  /CELLS MEAN COUNT STDDEV  .
