***** READING TEACHER AGGREGATION *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FILTER OFF.
USE ALL.
SELECT IF(idtr ~= "").
EXECUTE .

***** Aggregating xshadv at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISx.SAV'
  /BREAK=country region district 
  /misdisx= NMISS(xshadv)   
  /numdisx=N (idpupil)
  /optx1dis = PIN(xshadv 1 1)
  /optx2dis = PIN(xshadv 2 2)
  /optx3dis = PIN(xshadv 3 3)
  /optx4dis = PIN(xshadv 4 4)
.

***** Aggregating xshadv at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGx.SAV'
  /BREAK=country region 
  /misregx= NMISS(xshadv)   
  /numregx=N (idpupil)
  /optx1reg = PIN(xshadv 1 1)
  /optx2reg = PIN(xshadv 2 2)
  /optx3reg = PIN(xshadv 3 3)
  /optx4reg = PIN(xshadv 4 4)
.

***** Aggregating xshadv at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONx.SAV'
  /BREAK=country 
  /misconx= NMISS(xshadv)  
  /numconx=N (idpupil)
  /optx1con = PIN(xshadv 1 1)
  /optx2con = PIN(xshadv 2 2)
  /optx3con = PIN(xshadv 3 3)
  /optx4con = PIN(xshadv 4 4)
.

***** MATHEMATICS TEACHER AGGREGATION *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FILTER OFF.
USE ALL.
SELECT IF(idtm ~= "").
EXECUTE .

***** Aggregating yshadv at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISy.SAV'
  /BREAK=country region district 
  /misdisy= NMISS(yshadv)   
  /numdisy=N (idpupil)
  /opty1dis = PIN(yshadv 1 1)
  /opty2dis = PIN(yshadv 2 2)
  /opty3dis = PIN(yshadv 3 3)
  /opty4dis = PIN(yshadv 4 4)
.

***** Aggregating yshadv at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGy.SAV'
  /BREAK=country region 
  /misregy= NMISS(yshadv)   
  /numregy=N (idpupil)
  /opty1reg = PIN(yshadv 1 1)
  /opty2reg = PIN(yshadv 2 2)
  /opty3reg = PIN(yshadv 3 3)
  /opty4reg = PIN(yshadv 4 4)
.

***** Aggregating yshadv at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONy.SAV'
  /BREAK=country 
  /miscony= NMISS(yshadv)  
  /numcony=N (idpupil)
  /opty1con = PIN(yshadv 1 1)
  /opty2con = PIN(yshadv 2 2)
  /opty3con = PIN(yshadv 3 3)
  /opty4con = PIN(yshadv 4 4)
.

***** Merging back the different aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=xshadv yshadv
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISx.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGx.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONx.sav'
 /BY country .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISy.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGy.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONy.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misdispx= misdisx/numdisx.
compute misregpx= misregx/numregx.
compute misconpx= misconx/numconx.

compute misdispy= misdisy/numdisy.
compute misregpy= misregy/numregy.
compute misconpy= miscony/numcony.

EXECUTE .

***** Finding the Mode at each level *****.

if max(optx1dis, optx2dis, optx3dis, optx4dis)=optx4dis modedisx=4.
if max(optx1dis, optx2dis, optx3dis, optx4dis)=optx3dis modedisx=3.
if max(optx1dis, optx2dis, optx3dis, optx4dis)=optx2dis modedisx=2.
if max(optx1dis, optx2dis, optx3dis, optx4dis)=optx1dis modedisx=1.

if max(optx1reg, optx2reg, optx3reg, optx4reg)=optx4reg moderegx=4.
if max(optx1reg, optx2reg, optx3reg, optx4reg)=optx3reg moderegx=3.
if max(optx1reg, optx2reg, optx3reg, optx4reg)=optx2reg moderegx=2.
if max(optx1reg, optx2reg, optx3reg, optx4reg)=optx1reg moderegx=1.

if max(optx1con, optx2con, optx3con, optx4con)=optx4con modeconx=4.
if max(optx1con, optx2con, optx3con, optx4con)=optx3con modeconx=3.
if max(optx1con, optx2con, optx3con, optx4con)=optx2con modeconx=2.
if max(optx1con, optx2con, optx3con, optx4con)=optx1con modeconx=1.

if max(opty1dis, opty2dis, opty3dis, opty4dis)=opty4dis modedisy=4.
if max(opty1dis, opty2dis, opty3dis, opty4dis)=opty3dis modedisy=3.
if max(opty1dis, opty2dis, opty3dis, opty4dis)=opty2dis modedisy=2.
if max(opty1dis, opty2dis, opty3dis, opty4dis)=opty1dis modedisy=1.

if max(opty1reg, opty2reg, opty3reg, opty4reg)=opty4reg moderegy=4.
if max(opty1reg, opty2reg, opty3reg, opty4reg)=opty3reg moderegy=3.
if max(opty1reg, opty2reg, opty3reg, opty4reg)=opty2reg moderegy=2.
if max(opty1reg, opty2reg, opty3reg, opty4reg)=opty1reg moderegy=1.

if max(opty1con, opty2con, opty3con, opty4con)=opty4con modecony=4.
if max(opty1con, opty2con, opty3con, opty4con)=opty3con modecony=3.
if max(opty1con, opty2con, opty3con, opty4con)=opty2con modecony=2.
if max(opty1con, opty2con, opty3con, opty4con)=opty1con modecony=1.

***** Imputation of xshadv at district level *****.

if (idtr~="" and missing(xshadv) and misdispx~= 0 and misdispx LT .15) xshadv=modedisx.

FREQUENCIES
  VARIABLES=xshadv
  /ORDER  ANALYSIS .

***** Imputation of xshadv at region level *****.

if (idtr~="" and missing(xshadv) and misdispx GE .15 and misregpx~= 0 and misregpx LT .15) xshadv=moderegx.

FREQUENCIES
  VARIABLES=xshadv
  /ORDER  ANALYSIS .

***** Imputation of xshadv at country level *****.

if (idtr~="" and missing(xshadv) and misdispx GE .15 and misregpx GE .15 and misconpx~= 0 and misconpx LT .15) xshadv=modeconx.

FREQUENCIES
  VARIABLES=xshadv
  /ORDER  ANALYSIS .

***** No imputation of xshadv if more than 15% missing at country level *****.

if (idtr~="" and missing(xshadv) and misdispx GE .15 and misregpx GE .15 and misconpx GE .15) xshadv=xshadv.
FREQUENCIES
  VARIABLES=xshadv
  /ORDER  ANALYSIS .

***** Imputation of yshadv at district level *****.

if (idtm~="" and missing(yshadv) and misdispy~= 0 and misdispy LT .15) yshadv=modedisy.

FREQUENCIES
  VARIABLES=yshadv
  /ORDER  ANALYSIS .

***** Imputation of yshadv at region level *****.

if (idtm~="" and missing(yshadv) and misdispy GE .15 and misregpy~= 0 and misregpy LT .15) yshadv=moderegy.

FREQUENCIES
  VARIABLES=yshadv
  /ORDER  ANALYSIS .

***** Imputation of yshadv at country level *****.

if (idtm~="" and missing(yshadv) and misdispy GE .15 and misregpy GE .15 and misconpy~= 0 and misconpy LT .15) yshadv=modecony.

FREQUENCIES
  VARIABLES=yshadv
  /ORDER  ANALYSIS .

***** No imputation of yshadv if more than 15% missing at country level *****.

if (idtm~="" and missing(yshadv) and misdispy GE .15 and misregpy GE .15 and misconpy GE .15) yshadv=yshadv.
FREQUENCIES
  VARIABLES=yshadv
  /ORDER  ANALYSIS .

***** Checking if the same teacher was imputed with different values *****.

USE ALL.
COMPUTE filter_$=(idtr=idtm and xshadv~=yshadv ).
VARIABLE LABEL filter_$ 'idtr=idtm and xshadv~=yshadv  (FILTER)'.
VALUE LABELS filter_$  0 'Not Selected' 1 'Selected'.
FORMAT filter_$ (f1.0).
FILTER BY filter_$.
EXECUTE .

SUMMARIZE
  /TABLES=country region district idpupil idtr xshadv idtm yshadv
  /FORMAT=VALIDLIST NOCASENUM TOTAL
  /TITLE='same teacher but differently imputed'
  /MISSING=VARIABLE
  /CELLS=COUNT .

FILTER OFF.
USE ALL.
EXECUTE .

if idtr~= "" and idtm~= "" and idtr=idtm and xshadv~=yshadv yshadv=xshadv.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** computing derived variables *****.

RECODE
  xshadv yshadv
  (1=0)  (2=1)  (3=1)  (4=1)  (5=SYSMIS)  INTO  zxshadv  zyshadv .
EXECUTE .


***** saving imputed and derived variables *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\TQ22.sav' /keep country stratum idpupil xshadv yshadv zxshadv  zyshadv .

****Table 9.2 Percentage of teachers receiveing advice 'sometimes' or 'ofetn'*****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=zxshadv zyshadv  BY stratum
  /CELLS MEAN COUNT STDDEV  .
