GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=xrescent yrescent xresused yresused xresuse1 to xresuse6 yresuse1 to yresuse6 
  /ORDER  ANALYSIS .

*****TQ24.1-6 imputing missing to 1*****.

DO IF idtr~="".
  recode xresuse1 to xresuse6 (1=1) (2=2) (missing=1).
END IF.

FREQUENCIES
  VARIABLES=xresuse1 to xresuse6 
  /ORDER  ANALYSIS .

DO IF idtm~="".
  recode yresuse1 to yresuse6 (1=1) (2=2) (missing=1).
END IF.

FREQUENCIES
  VARIABLES=yresuse1 to yresuse6 
  /ORDER  ANALYSIS .

*****Consistency check between TQ24 and TQ24.1-6*****.

DO IF idtr~="".
  compute x24=0.
  if  (xresuse1=2 or xresuse2=2  or xresuse3=2 or xresuse4=2 or xresuse5=2 or xresuse6=2) x24=1.
END IF.

DO IF idtm~="".
  compute y24=0.
  if  (yresuse1=2 or yresuse2=2  or yresuse3=2 or yresuse4=2 or yresuse5=2 or yresuse6=2) y24=1.
END IF.

FREQUENCIES
  VARIABLES=x24 y24 
  /ORDER=  ANALYSIS .

if idtr~="" and x24=1 xresused=3.
if idtr~="" and x24=0 and xresused=3 xresuse6=2.

if idtm~="" and y24=1 yresused=3.
if idtm~="" and y24=0 and yresused=3 yresuse6=2.

*****Consistency check between TQ23 and TQ24*****.

if (idtr~="") and missing(xresused) and missing(xrescent) xresused=1.
if (idtr~="") and missing(xresused) and xrescent=1 xresused=1.
if (idtr~="") and missing(xresused) and xrescent=2 xresused=2.

if (idtr~="") and xresused=1 xrescent=1.
if (idtr~="") and xresused=2 xrescent=2.
if (idtr~="") and xresused=3 xrescent=2.
 
if (idtm~="") and missing(yresused) and missing(yrescent) yresused=1.
if (idtm~="") and missing(yresused) and yrescent=1 yresused=1.
if (idtm~="") and missing(yresused) and yrescent=2 yresused=2.

if (idtm~="") and yresused=1 yrescent=1.
if (idtm~="") and yresused=2 yrescent=2.
if (idtm~="") and yresused=3 yrescent=2.

FREQUENCIES
  VARIABLES= xrescent xresused yrescent yresused
  /ORDER=  ANALYSIS .

CROSSTABS
  /TABLES=xrescent  BY xresused
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT .

CROSSTABS
  /TABLES=xresuse1 xresuse2 xresuse3 xresuse4 xresuse5 xresuse6 BY xresused
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT .

CROSSTABS
  /TABLES=yrescent  BY yresused
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT .

CROSSTABS
  /TABLES=yresuse1 yresuse2 yresuse3 yresuse4 yresuse5 yresuse6 BY yresused
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT .

***** derived variables *****.

DO IF idtr~="".
   recode xresused (1=sysmis) (2=1) (3=0) into zxresuse.
   recode xresuse1 to xresuse3 (1=0) (2=1) into zxreus1 to zxreus3.
   compute zxreus45=0.
   if (xresuse4=2 or xresuse5=2) zxreus45=1.
END IF.

DO IF idtm~="".
   recode yresused (1=sysmis) (2=1) (3=0) into zyresuse.
   recode yresuse1 to yresuse3 (1=0) (2=1) into zyreus1 to zyreus3.
   compute zyreus45=0.
   if (yresuse4=2 or yresuse5=2) zyreus45=1.
END IF.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\TQ23_24.sav' /keep country stratum idpupil  xrescent xresused xresuse1 xresuse2
 xresuse3 xresuse4 xresuse5 xresuse6 yrescent yresused yresuse1 yresuse2 yresuse3 yresuse4 yresuse5 yresuse6
 zxresuse zxreus1 to zxreus3 zxreus45 zyresuse zyreus1 to zyreus3 zyreus45.

***** Table 8.6 availability of educational resource center*****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

CROSSTABS
  /TABLES=stratum  BY xresused yresused
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT ROW .

***** Table 11.10 Resource Centre Use *****.

MEANS
  TABLES=zxresuse zxreus1 to zxreus3 zxreus45 zyresuse zyreus1 to zyreus3 zyreus45
BY stratum
  /CELLS MEAN COUNT STDDEV  .

***************************************************************************************************************.
***************************************************************************************************************.
***************************************************************************************************************.
*****impute missing between SQ26 & SQ27 and consistency check between SQ26 & SQ27******.
***************************************************************************************************************.
***consistency in SQ26***.
count schmis=ssex to sprobcom (missing).
execute.

SPLIT FILE
  OFF.

CROSSTABS
  /TABLES=scntr  BY scntrvis
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT .

DO IF (schmis~=169 and SCNTR=1 and scntrvis=0 ) .
RECODE
  scntrvis  (0=SYSMIS)  .
END IF .

if schmis~=169 and SCNTR=2 and missing(scntrvis) scntrvis=0.
if schmis~=169 and SCNTR=3 and scntrvis=0 scntr=2.
IF schmis~=169 and scntrvis >= 1 scntr = 3 .

CROSSTABS
  /TABLES=scntr  BY scntrvis
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT .

***missing SQ26 & SQ27***.

FREQUENCIES
  VARIABLES=scntr scntrsrv
  /ORDER=  ANALYSIS .

if schmis~=169 and missing(SCNTR) and scntrsrv=1 SCNTR=1.
if schmis~=169 and missing(SCNTR) and (scntrsrv=2 or scntrsrv=3 or scntrsrv=4 or scntrsrv=5) and (missing(scntrvis) or scntrvis=0) SCNTR=2.
if schmis~=169 and missing(SCNTR) and (scntrsrv=2 or scntrsrv=3 or scntrsrv=4 or scntrsrv=5) and (scntrvis >= 1) SCNTR=3.
if schmis~=169 and missing(SCNTRsrv) and missing(SCNTR) and (scntrvis >= 1) scntr=3.
if schmis~=169 and missing(SCNTRsrv) and scntr=1 SCNTRsrv=1.
if schmis~=169 and missing(SCNTRsrv) and (scntr=2 or scntr=3) SCNTRsrv=SCNTRsrv.
execute.

FREQUENCIES
  VARIABLES=scntr 
  /ORDER=  ANALYSIS .

***consistency between SQ26 and SQ27***.

CROSSTABS
  /TABLES=scntr  BY scntrsrv
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT .

if schmis~=169 and (SCNTR=2 or SCNTR=3) and scntrsrv=1 and (scntrvis=0 or missing(scntrvis)) SCNTR=1.
if schmis~=169 and SCNTR=3 and scntrsrv=1 and (scntrvis >= 1) SCNTRsrv=7.
if schmis~=169 and  SCNTR=1 and (scntrsrv=2 or scntrsrv=3 or scntrsrv=4 or scntrsrv=5 or scntrsrv=6) SCNTR=2.
execute.

CROSSTABS
  /TABLES=scntr  BY scntrsrv
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT .

CROSSTABS
  /TABLES=scntr  BY scntrvis
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT .


*****impute missing in SQ26 and S27 by using TQ23*****.

FREQUENCIES
  VARIABLES=scntr scntrvis scntrsrv
  /ORDER=  ANALYSIS .

if schmis~=169 and missing(SCNTR) and (xrescent=1 and yrescent=1)  SCNTR=1.
if schmis~=169 and missing(SCNTR) and (xrescent=1 and missing(yrescent))  SCNTR=1.
if schmis~=169 and missing(SCNTR) and (missing(xrescent) and yrescent=1)  SCNTR=1.
if schmis~=169 and missing(SCNTR) and (xrescent=2 or yrescent=2)  SCNTR=2.
execute.

if schmis~=169 and missing(SCNTRsrv) and scntr=1  SCNTRsrv=1.
if schmis~=169 and missing(SCNTRsrv) and scntr=2  SCNTRsrv=7.
if schmis~=169 and missing(SCNTRsrv) and scntr=3  SCNTRsrv=7.
execute.

FREQUENCIES
  VARIABLES=scntr scntrsrv 
  /ORDER=  ANALYSIS .

CROSSTABS
  /TABLES=scntr  BY scntrsrv
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT .

RECODE
  scntrsrv  (7=SYSMIS)  .
EXECUTE .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***************************************************.
******Impute remaining missing in SQ27*****.
***************************************************.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

FILTER OFF.
USE ALL.
SELECT IF(schmis~=169).
EXECUTE .


***** Aggregating at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /misdis= NMISS(scntrsrv)   
  /numdis=N (idpupil)
  /opt_5dis = PIN(scntrsrv 5 5)
  /opt_2dis = PIN(scntrsrv 2 2)
  /opt_3dis = PIN(scntrsrv 3 3)
  /opt_4dis = PIN(scntrsrv 4 4)
 
.

***** Aggregating at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /misreg= NMISS(scntrsrv)   
  /numreg=N (idpupil)
  /opt_5reg = PIN(scntrsrv 5 5)
  /opt_2reg = PIN(scntrsrv 2 2)
  /opt_3reg = PIN(scntrsrv 3 3)
  /opt_4reg = PIN(scntrsrv 4 4)
.

***** Aggregating at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /miscon= NMISS(scntrsrv)  
  /numcon=N (idpupil)
  /opt_5con = PIN(scntrsrv 5 5)
  /opt_2con = PIN(scntrsrv 2 2)
  /opt_3con = PIN(scntrsrv 3 3)
  /opt_4con = PIN(scntrsrv 4 4)
.

***** Merging back the different aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

count schmis=ssex to sprobcom (missing).

FILTER OFF.
USE ALL.
SELECT IF(schmis~=169).
EXECUTE .

FREQUENCIES
  VARIABLES=scntrsrv
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.
EXECUTE .

compute misdisp= misdis/numdis.
compute misregp= misreg/numreg.
compute misconp= miscon/numcon.
EXECUTE .

***** Finding the Mode at each level *****.

if max(opt_5dis, opt_2dis, opt_3dis, opt_4dis)=opt_4dis modedis=4.
if max(opt_5dis, opt_2dis, opt_3dis, opt_4dis)=opt_3dis modedis=3.
if max(opt_5dis, opt_2dis, opt_3dis, opt_4dis)=opt_2dis modedis=2.
if max(opt_5dis, opt_2dis, opt_3dis, opt_4dis)=opt_5dis modedis=5.

if max(opt_5reg, opt_2reg, opt_3reg, opt_4reg)=opt_4reg modereg=4.
if max(opt_5reg, opt_2reg, opt_3reg, opt_4reg)=opt_3reg modereg=3.
if max(opt_5reg, opt_2reg, opt_3reg, opt_4reg)=opt_2reg modereg=2.
if max(opt_5reg, opt_2reg, opt_3reg, opt_4reg)=opt_5reg modereg=5.

if max(opt_5con, opt_2con, opt_3con, opt_4con)=opt_4con modecon=4.
if max(opt_5con, opt_2con, opt_3con, opt_4con)=opt_3con modecon=3.
if max(opt_5con, opt_2con, opt_3con, opt_4con)=opt_2con modecon=2.
if max(opt_5con, opt_2con, opt_3con, opt_4con)=opt_5con modecon=5.

***** Imputation at district level *****.

if (missing(scntrsrv) and misdisp~= 0 and misdisp LT .15) scntrsrv=modedis.

FREQUENCIES
  VARIABLES=scntrsrv
  /ORDER  ANALYSIS .

***** Imputation at region level *****.

if (missing(scntrsrv) and misdisp GE .15 and misregp~= 0 and misregp LT .15) scntrsrv=modereg.

FREQUENCIES
  VARIABLES=scntrsrv
  /ORDER  ANALYSIS .

***** Imputation at country level *****.

if (missing(scntrsrv) and misdisp GE .15 and misregp GE .15 and misconp~= 0 and misconp LT .15) scntrsrv=modecon.

FREQUENCIES
  VARIABLES=scntrsrv
  /ORDER  ANALYSIS .

***** No imputation of xqacad if more than 15% missing at country level *****.

if (missing(scntrsrv) and misdisp GE .15 and misregp GE .15 and misconp GE .15) scntrsrv=scntrsrv.

FREQUENCIES
  VARIABLES=scntrsrv
  /ORDER  ANALYSIS .

*****consistency check*****.

CROSSTABS
  /TABLES=scntr  BY scntrvis
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT .

DO IF (SCNTR=1 and scntrvis=0 ) .
RECODE
  scntrvis  (0=SYSMIS)  .
END IF .
EXECUTE .

CROSSTABS
  /TABLES=scntr  BY scntrvis
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** saving imputed and derived variables *****.

DO IF schmis~=169.
   recode scntr (1=sysmis) (2=0) (3=1) into ZSCNTR.
   recode scntrsrv (1=0) (2=3) (3=8) (4=13) (5=20) into ZSCNTRSR.
END IF.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\SQ26_27.sav' /keep country stratum idpupil scntr scntrvis scntrsrv ZSCNTR ZSCNTRSR.
