***** READING TEACHER AGGREGATION *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FILTER OFF.
USE ALL.
SELECT IF(idtr ~= "").
EXECUTE .

***** Aggregating xliving at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISx.SAV'
  /BREAK=country region district 
  /misdisx= NMISS(xliving) 
  /numdisx=N (idpupil)
  /optx1dis = PIN(xliving 1 1)
  /optx2dis = PIN(xliving 2 2)
  /optx3dis = PIN(xliving 3 3)
  /optx4dis = PIN(xliving 4 4)
.

***** Aggregating xliving at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGx.SAV'
  /BREAK=country region 
  /misregx= NMISS(xliving)   
  /numregx=N (idpupil)
  /optx1reg = PIN(xliving 1 1)
  /optx2reg = PIN(xliving 2 2)
  /optx3reg = PIN(xliving 3 3)
  /optx4reg = PIN(xliving 4 4)
.

***** Aggregating xliving at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONx.SAV'
  /BREAK=country 
  /misconx= NMISS(xliving)  
  /numconx=N (idpupil)
  /optx1con = PIN(xliving 1 1)
  /optx2con = PIN(xliving 2 2)
  /optx3con = PIN(xliving 3 3)
  /optx4con = PIN(xliving 4 4)
.

***** MATHEMATICS TEACHER AGGREGATION *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FILTER OFF.
USE ALL.
SELECT IF(idtm ~= "").
EXECUTE .

***** Aggregating yliving at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISy.SAV'
  /BREAK=country region district 
  /misdisy= NMISS(yliving)   
  /numdisy=N (idpupil)
  /opty1dis = PIN(yliving 1 1)
  /opty2dis = PIN(yliving 2 2)
  /opty3dis = PIN(yliving 3 3)
  /opty4dis = PIN(yliving 4 4)
.

***** Aggregating yliving at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGy.SAV'
  /BREAK=country region 
  /misregy= NMISS(yliving)   
  /numregy=N (idpupil)
  /opty1reg = PIN(yliving 1 1)
  /opty2reg = PIN(yliving 2 2)
  /opty3reg = PIN(yliving 3 3)
  /opty4reg = PIN(yliving 4 4)
.

***** Aggregating yliving at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONy.SAV'
  /BREAK=country 
  /miscony= NMISS(yliving)  
  /numcony=N (idpupil)
  /opty1con = PIN(yliving 1 1)
  /opty2con = PIN(yliving 2 2)
  /opty3con = PIN(yliving 3 3)
  /opty4con = PIN(yliving 4 4)
.

***** Merging back the different aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

recode xliving yliving (missing=sysmis).

FREQUENCIES
  VARIABLES=xliving yliving
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISx.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGx.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONx.sav'
 /BY country .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDISy.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREGy.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCONy.sav'
 /BY country .
EXECUTE.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misdispx= misdisx/numdisx.
compute misregpx= misregx/numregx.
compute misconpx= misconx/numconx.

compute misdispy= misdisy/numdisy.
compute misregpy= misregy/numregy.
compute misconpy= miscony/numcony.

EXECUTE .

***** Finding the Mode at each level *****.

if max(optx1dis, optx2dis, optx3dis, optx4dis)=optx4dis modedisx=4.
if max(optx1dis, optx2dis, optx3dis, optx4dis)=optx3dis modedisx=3.
if max(optx1dis, optx2dis, optx3dis, optx4dis)=optx2dis modedisx=2.
if max(optx1dis, optx2dis, optx3dis, optx4dis)=optx1dis modedisx=1.

if max(optx1reg, optx2reg, optx3reg, optx4reg)=optx4reg moderegx=4.
if max(optx1reg, optx2reg, optx3reg, optx4reg)=optx3reg moderegx=3.
if max(optx1reg, optx2reg, optx3reg, optx4reg)=optx2reg moderegx=2.
if max(optx1reg, optx2reg, optx3reg, optx4reg)=optx1reg moderegx=1.

if max(optx1con, optx2con, optx3con, optx4con)=optx4con modeconx=4.
if max(optx1con, optx2con, optx3con, optx4con)=optx3con modeconx=3.
if max(optx1con, optx2con, optx3con, optx4con)=optx2con modeconx=2.
if max(optx1con, optx2con, optx3con, optx4con)=optx1con modeconx=1.

if max(opty1dis, opty2dis, opty3dis, opty4dis)=opty4dis modedisy=4.
if max(opty1dis, opty2dis, opty3dis, opty4dis)=opty3dis modedisy=3.
if max(opty1dis, opty2dis, opty3dis, opty4dis)=opty2dis modedisy=2.
if max(opty1dis, opty2dis, opty3dis, opty4dis)=opty1dis modedisy=1.

if max(opty1reg, opty2reg, opty3reg, opty4reg)=opty4reg moderegy=4.
if max(opty1reg, opty2reg, opty3reg, opty4reg)=opty3reg moderegy=3.
if max(opty1reg, opty2reg, opty3reg, opty4reg)=opty2reg moderegy=2.
if max(opty1reg, opty2reg, opty3reg, opty4reg)=opty1reg moderegy=1.

if max(opty1con, opty2con, opty3con, opty4con)=opty4con modecony=4.
if max(opty1con, opty2con, opty3con, opty4con)=opty3con modecony=3.
if max(opty1con, opty2con, opty3con, opty4con)=opty2con modecony=2.
if max(opty1con, opty2con, opty3con, opty4con)=opty1con modecony=1.

***** Imputation of xliving at district level *****.

if (idtr~="" and missing(xliving) and misdispx~= 0 and misdispx LT .15) xliving=modedisx.

FREQUENCIES
  VARIABLES=xliving
  /ORDER  ANALYSIS .

***** Imputation of xliving at region level *****.

if (idtr~="" and missing(xliving) and misdispx GE .15 and misregpx~= 0 and misregpx LT .15) xliving=moderegx.

FREQUENCIES
  VARIABLES=xliving
  /ORDER  ANALYSIS .

***** Imputation of xliving at country level *****.

if (idtr~="" and missing(xliving) and misdispx GE .15 and misregpx GE .15 and misconpx~= 0 and misconpx LT .15) xliving=modeconx.

FREQUENCIES
  VARIABLES=xliving
  /ORDER  ANALYSIS .

***** No imputation of xliving if more than 15% missing at country level *****.

if (idtr~="" and missing(xliving) and misdispx GE .15 and misregpx GE .15 and misconpx GE .15) xliving=xliving.

FREQUENCIES
  VARIABLES=xliving
  /ORDER  ANALYSIS .

***** Imputation of yliving at district level *****.

if (idtm~="" and missing(yliving) and misdispy~= 0 and misdispy LT .15) yliving=modedisy.

FREQUENCIES
  VARIABLES=yliving
  /ORDER  ANALYSIS .

***** Imputation of yliving at region level *****.

if (idtm~="" and missing(yliving) and misdispy GE .15 and misregpy~= 0 and misregpy LT .15) yliving=moderegy.

FREQUENCIES
  VARIABLES=yliving
  /ORDER  ANALYSIS .

***** Imputation of yliving at country level *****.

if (idtm~="" and missing(yliving) and misdispy GE .15 and misregpy GE .15 and misconpy~= 0 and misconpy LT .15) yliving=modecony.

FREQUENCIES
  VARIABLES=yliving
  /ORDER  ANALYSIS .

***** No imputation of yliving if more than 15% missing at country level *****.

if (idtm~="" and missing(yliving) and misdispy GE .15 and misregpy GE .15 and misconpy GE .15) yliving=yliving.

FREQUENCIES
  VARIABLES=yliving
  /ORDER  ANALYSIS .

***** Checking if the same teacher was imputed with different values *****.

USE ALL.
COMPUTE filter_$=(idtr=idtm and xliving~=yliving ).
VARIABLE LABEL filter_$ 'idtr=idtm and xliving~=yliving   (FILTER)'.
VALUE LABELS filter_$  0 'Not Selected' 1 'Selected'.
FORMAT filter_$ (f1.0).
FILTER BY filter_$.
EXECUTE .

SUMMARIZE
  /TABLES=country region district idpupil idtr xliving idtm yliving
  /FORMAT=VALIDLIST NOCASENUM TOTAL
  /TITLE='same teacher but differently imputed'
  /MISSING=VARIABLE
  /CELLS=COUNT .

FILTER OFF.
USE ALL.
EXECUTE .

if idtr~= "" and idtm~= "" and idtr=idtm and xliving~=yliving yliving=xliving.

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** calculating derived variable *****.

DO IF idtr~= "" .
  RECODE  xliving   (1 thru 2=0)  (3 thru 4=1)  INTO  zxcondli  .
END IF.

DO IF idtm~= "" .
  RECODE   yliving  (1 thru 2=0)  (3 thru 4=1)  INTO    zycondli  .
END IF.

***** saving imputed and derived variables *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\TQ30.sav' /keep country stratum idpupil xliving yliving zxcondli  zycondli  .

****Table 4.5 Teacher Living Condition *****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=zxcondli  zycondli  BY stratum
  /CELLS MEAN COUNT STDDEV  .
