GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FILTER OFF.
USE ALL.
SELECT IF(idtr ~= "").
EXECUTE .

***** Aggregating trgoal02 at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /misdis= NMISS(trgoal02)   
  /numdis=N (idpupil)
  /opt1dis = PIN(trgoal02 1 1)
  /opt2dis = PIN(trgoal02 2 2)
  /opt3dis = PIN(trgoal02 3 3)
 .

***** Aggregating trgoal02 at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /misreg= NMISS(trgoal02)   
  /numreg=N (idpupil)
  /opt1reg = PIN(trgoal02 1 1)
  /opt2reg = PIN(trgoal02 2 2)
  /opt3reg = PIN(trgoal02 3 3)
  .

***** Aggregating trgoal02 at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /miscon= NMISS(trgoal02)  
  /numcon=N (idpupil)
  /opt1con = PIN(trgoal02 1 1)
  /opt2con = PIN(trgoal02 2 2)
  /opt3con = PIN(trgoal02 3 3)
.

***** Merging back the aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=trgoal02 
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misdisp= misdis/numdis.
compute misregp= misreg/numreg.
compute misconp= miscon/numcon.

EXECUTE .

***** Finding the Mode at each level *****.

if max(opt1dis, opt2dis, opt3dis)=opt3dis modedis=3.
if max(opt1dis, opt2dis, opt3dis)=opt2dis modedis=2.
if max(opt1dis, opt2dis, opt3dis)=opt1dis modedis=1.

if max(opt1reg, opt2reg, opt3reg)=opt3reg modereg=3.
if max(opt1reg, opt2reg, opt3reg)=opt2reg modereg=2.
if max(opt1reg, opt2reg, opt3reg)=opt1reg modereg=1.

if max(opt1con, opt2con, opt3con)=opt3con modecon=3.
if max(opt1con, opt2con, opt3con)=opt2con modecon=2.
if max(opt1con, opt2con, opt3con)=opt1con modecon=1.

***** Imputation of trgoal02 at district level *****.

if (idtr~="" and missing(trgoal02) and misdisp~= 0 and misdisp LT .15) trgoal02=modedis.

FREQUENCIES
  VARIABLES=trgoal01
  /ORDER  ANALYSIS .

***** Imputation of trgoal02 at region level *****.

if (idtr~="" and missing(trgoal02) and misdisp GE .15 and misregp~= 0 and misregp LT .15) trgoal02=modereg.

FREQUENCIES
  VARIABLES=trgoal02
  /ORDER  ANALYSIS .

***** Imputation of trgoal02 at country level *****.

if (idtr~="" and missing(trgoal02) and misdisp GE .15 and misregp GE .15 and misconp~= 0 and misconp LT .15) trgoal02=modecon.

FREQUENCIES
  VARIABLES=trgoal02
  /ORDER  ANALYSIS .

***** No imputation of trgoal02 if more than 15% missing at country level *****.

if (idtr~="" and missing(trgoal02) and misdisp GE .15 and misregp GE .15 and misconp GE .15) trgoal02=trgoal02.

FREQUENCIES
  VARIABLES=trgoal02
  /ORDER  ANALYSIS .

***** Automatic Cleaning using TQ36 (most important) *****.

sort cases by country (a) stratum (a) idpupil (a).

MATCH FILES /FILE=*
 /FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\TQ36.sav'
 /RENAME (trgoalmo= d0  ) 
 /BY country stratum idpupil.
EXECUTE.

compute trgoalmo=d0.

if trgoalmo=2 trgoal02=3.

***** saving imputed variables *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\TQ35.2.sav' /keep country stratum idpupil trgoal02 .
