
GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FILTER OFF.
USE ALL.
SELECT IF(idtr ~= "").
EXECUTE .

***** Aggregating trappr03 at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /misdis= NMISS(trappr03)   
  /numdis=N (idpupil)
  /opt1dis = PIN(trappr03 1 1)
  /opt2dis = PIN(trappr03 2 2)
  /opt3dis = PIN(trappr03 3 3)
 
 .

***** Aggregating trappr03 at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /misreg= NMISS(trappr03)   
  /numreg=N (idpupil)
  /opt1reg = PIN(trappr03 1 1)
  /opt2reg = PIN(trappr03 2 2)
  /opt3reg = PIN(trappr03 3 3)
    .

***** Aggregating trappr03 at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /miscon= NMISS(trappr03)  
  /numcon=N (idpupil)
  /opt1con = PIN(trappr03 1 1)
  /opt2con = PIN(trappr03 2 2)
  /opt3con = PIN(trappr03 3 3)
 
.

***** Merging back the aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=trappr03 
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misdisp= misdis/numdis.
compute misregp= misreg/numreg.
compute misconp= miscon/numcon.

EXECUTE .

***** Finding the Mode at each level *****.

if max(opt1dis, opt2dis, opt3dis)=opt3dis modedis=3.
if max(opt1dis, opt2dis, opt3dis)=opt2dis modedis=2.
if max(opt1dis, opt2dis, opt3dis)=opt1dis modedis=1.

if max(opt1reg, opt2reg, opt3reg)=opt3reg modereg=3.
if max(opt1reg, opt2reg, opt3reg)=opt2reg modereg=2.
if max(opt1reg, opt2reg, opt3reg)=opt1reg modereg=1.

if max(opt1con, opt2con, opt3con)=opt3con modecon=3.
if max(opt1con, opt2con, opt3con)=opt2con modecon=2.
if max(opt1con, opt2con, opt3con)=opt1con modecon=1.


***** Imputation of trappr03 at district level *****.

if (idtr~="" and missing(trappr03) and misdisp~= 0 and misdisp LT .15) trappr03=modedis.

FREQUENCIES
  VARIABLES=trappr03
  /ORDER  ANALYSIS .

***** Imputation of trappr03 at region level *****.

if (idtr~="" and missing(trappr03) and misdisp GE .15 and misregp~= 0 and misregp LT .15) trappr03=modereg.

FREQUENCIES
  VARIABLES=trappr03
  /ORDER  ANALYSIS .

***** Imputation of trappr03 at country level *****.

if (idtr~="" and missing(trappr03) and misdisp GE .15 and misregp GE .15 and misconp~= 0 and misconp LT .15) trappr03=modecon.

FREQUENCIES
  VARIABLES=trappr03
  /ORDER  ANALYSIS .

***** No imputation of trappr03 if more than 15% missing at country level *****.

if (idtr~="" and missing(trappr03) and misdisp GE .15 and misregp GE .15 and misconp GE .15) trappr03=trappr03.
FREQUENCIES
  VARIABLES=trappr03
  /ORDER  ANALYSIS .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

*****computing derived variables *****.

RECODE
  trappr03
  (1=0)  (2=0)  (3=1)  INTO  ztrapp03 .
EXECUTE .

***** saving imputed variables *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\TQ37.3.sav' /keep country stratum idpupil trappr03 ztrapp03 .

****Table 8.1(a) Percenttage indicating 'often used''*****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=ztrapp03  BY stratum
  /CELLS MEAN COUNT STDDEV  .
