
GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FILTER OFF.
USE ALL.
SELECT IF(idtr ~= "").
EXECUTE .

***** Aggregating ttestrea at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /misdis= NMISS(ttestrea)   
  /numdis=N (idpupil)
  /opt1dis = PIN(ttestrea 1 1)
  /opt2dis = PIN(ttestrea 2 2)
  /opt3dis = PIN(ttestrea 3 3)
  /opt4dis = PIN(ttestrea 4 4)
  /opt5dis = PIN(ttestrea 5 5)
  /opt6dis = PIN(ttestrea 6 6)
 .

***** Aggregating ttestrea at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /misreg= NMISS(ttestrea)   
  /numreg=N (idpupil)
  /opt1reg = PIN(ttestrea 1 1)
  /opt2reg = PIN(ttestrea 2 2)
  /opt3reg = PIN(ttestrea 3 3)
  /opt4reg = PIN(ttestrea 4 4)
  /opt5reg = PIN(ttestrea 5 5)
  /opt6reg = PIN(ttestrea 6 6)
  .

***** Aggregating ttestrea at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /miscon= NMISS(ttestrea)  
  /numcon=N (idpupil)
  /opt1con = PIN(ttestrea 1 1)
  /opt2con = PIN(ttestrea 2 2)
  /opt3con = PIN(ttestrea 3 3)
  /opt4con = PIN(ttestrea 4 4)
  /opt5con = PIN(ttestrea 5 5)
  /opt6con = PIN(ttestrea 6 6)
.

***** Merging back the aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=ttestrea 
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misdisp= misdis/numdis.
compute misregp= misreg/numreg.
compute misconp= miscon/numcon.

EXECUTE .

***** Finding the Mode at each level *****.

if max(opt1dis, opt2dis, opt3dis, opt4dis, opt5dis, opt6dis)=opt6dis modedis=6.
if max(opt1dis, opt2dis, opt3dis, opt4dis, opt5dis, opt6dis)=opt5dis modedis=5.
if max(opt1dis, opt2dis, opt3dis, opt4dis, opt5dis, opt6dis)=opt4dis modedis=4.
if max(opt1dis, opt2dis, opt3dis, opt4dis, opt5dis, opt6dis)=opt3dis modedis=3.
if max(opt1dis, opt2dis, opt3dis, opt4dis, opt5dis, opt6dis)=opt2dis modedis=2.
if max(opt1dis, opt2dis, opt3dis, opt4dis, opt5dis, opt6dis)=opt1dis modedis=1.

if max(opt1reg, opt2reg, opt3reg, opt4reg, opt5reg, opt6reg)=opt6reg modereg=6.
if max(opt1reg, opt2reg, opt3reg, opt4reg, opt5reg, opt6reg)=opt5reg modereg=5.
if max(opt1reg, opt2reg, opt3reg, opt4reg, opt5reg, opt6reg)=opt4reg modereg=4.
if max(opt1reg, opt2reg, opt3reg, opt4reg, opt5reg, opt6reg)=opt3reg modereg=3.
if max(opt1reg, opt2reg, opt3reg, opt4reg, opt5reg, opt6reg)=opt2reg modereg=2.
if max(opt1reg, opt2reg, opt3reg, opt4reg, opt5reg, opt6reg)=opt1reg modereg=1.

if max(opt1con, opt2con, opt3con, opt4con, opt5con, opt6con)=opt6con modecon=6.
if max(opt1con, opt2con, opt3con, opt4con, opt5con, opt6con)=opt5con modecon=5.
if max(opt1con, opt2con, opt3con, opt4con, opt5con, opt6con)=opt4con modecon=4.
if max(opt1con, opt2con, opt3con, opt4con, opt5con, opt6con)=opt3con modecon=3.
if max(opt1con, opt2con, opt3con, opt4con, opt5con, opt6con)=opt2con modecon=2.
if max(opt1con, opt2con, opt3con, opt4con, opt5con, opt6con)=opt1con modecon=1.


***** Imputation of ttestrea at district level *****.

if (idtr~="" and missing(ttestrea) and misdisp~= 0 and misdisp LT .15) ttestrea=modedis.

FREQUENCIES
  VARIABLES=ttestrea
  /ORDER  ANALYSIS .

***** Imputation of ttestrea at region level *****.

if (idtr~="" and missing(ttestrea) and misdisp GE .15 and misregp~= 0 and misregp LT .15) ttestrea=modereg.

FREQUENCIES
  VARIABLES=ttestrea
  /ORDER  ANALYSIS .

***** Imputation of ttestrea at country level *****.

if (idtr~="" and missing(ttestrea) and misdisp GE .15 and misregp GE .15 and misconp~= 0 and misconp LT .15) ttestrea=modecon.

FREQUENCIES
  VARIABLES=ttestrea
  /ORDER  ANALYSIS .

***** No imputation of ttestrea if more than 15% missing at country level *****.

if (idtr~="" and missing(ttestrea) and misdisp GE .15 and misregp GE .15 and misconp GE .15) ttestrea=ttestrea.
FREQUENCIES
  VARIABLES=ttestrea
  /ORDER  ANALYSIS .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** computing derived variables *****.

RECODE
  ttestrea
  (1=0)  (2=0)  (3=0)  (4=0)  (5=1)  (6=2)  INTO  zttestre .
EXECUTE .

***** saving imputed variables *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\TQ38.sav' /keep country stratum idpupil ttestrea zttestre .

****Table 8.1(a) Frequency of reading test'*****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

FREQUENCIES
  VARIABLES=zttestre
  /ORDER=  ANALYSIS .
