GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FILTER OFF.
USE ALL.
SELECT IF(idtm ~= "").
EXECUTE .

***** Aggregating tmgoal03 at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /misdis= NMISS(tmgoal03)   
  /numdis=N (idpupil)
  /opt1dis = PIN(tmgoal03 1 1)
  /opt2dis = PIN(tmgoal03 2 2)
  /opt3dis = PIN(tmgoal03 3 3)
 .

***** Aggregating tmgoal03 at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /misreg= NMISS(tmgoal03)   
  /numreg=N (idpupil)
  /opt1reg = PIN(tmgoal03 1 1)
  /opt2reg = PIN(tmgoal03 2 2)
  /opt3reg = PIN(tmgoal03 3 3)
  .

***** Aggregating tmgoal03 at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /miscon= NMISS(tmgoal03)  
  /numcon=N (idpupil)
  /opt1con = PIN(tmgoal03 1 1)
  /opt2con = PIN(tmgoal03 2 2)
  /opt3con = PIN(tmgoal03 3 3)
.

***** Merging back the aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=tmgoal03 
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misdisp= misdis/numdis.
compute misregp= misreg/numreg.
compute misconp= miscon/numcon.

EXECUTE .

***** Finding the Mode at each level *****.

if max(opt1dis, opt2dis, opt3dis)=opt3dis modedis=3.
if max(opt1dis, opt2dis, opt3dis)=opt2dis modedis=2.
if max(opt1dis, opt2dis, opt3dis)=opt1dis modedis=1.

if max(opt1reg, opt2reg, opt3reg)=opt3reg modereg=3.
if max(opt1reg, opt2reg, opt3reg)=opt2reg modereg=2.
if max(opt1reg, opt2reg, opt3reg)=opt1reg modereg=1.

if max(opt1con, opt2con, opt3con)=opt3con modecon=3.
if max(opt1con, opt2con, opt3con)=opt2con modecon=2.
if max(opt1con, opt2con, opt3con)=opt1con modecon=1.

***** Imputation of tmgoal03 at district level *****.

if (idtm~="" and missing(tmgoal03) and misdisp~= 0 and misdisp LT .15) tmgoal03=modedis.

FREQUENCIES
  VARIABLES=tmgoal03
  /ORDER  ANALYSIS .

***** Imputation of tmgoal03 at region level *****.

if (idtm~="" and missing(tmgoal03) and misdisp GE .15 and misregp~= 0 and misregp LT .15) tmgoal03=modereg.

FREQUENCIES
  VARIABLES=tmgoal03
  /ORDER  ANALYSIS .

***** Imputation of tmgoal03 at country level *****.

if (idtm~="" and missing(tmgoal03) and misdisp GE .15 and misregp GE .15 and misconp~= 0 and misconp LT .15) tmgoal03=modecon.

FREQUENCIES
  VARIABLES=tmgoal03
  /ORDER  ANALYSIS .

***** No imputation of tmgoal03 if more than 15% missing at country level *****.

if (idtm~="" and missing(tmgoal03) and misdisp GE .15 and misregp GE .15 and misconp GE .15) tmgoal03=tmgoal03.

FREQUENCIES
  VARIABLES=tmgoal03
  /ORDER  ANALYSIS .

***** Automatic Cleaning using TQ44 (most important) *****.

sort cases by country (a) stratum (a) idpupil (a).

MATCH FILES /FILE=*
 /FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\TQ44.sav'
 /RENAME (TMGOALMO= d0  ) 
 /BY country stratum idpupil.
EXECUTE.

compute TMGOALMO=d0.

if TMGOALMO=3 tmgoal03=3.

***** saving imputed variables *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\TQ43.3.sav' /keep country stratum idpupil tmgoal03 .

