
GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FILTER OFF.
USE ALL.
SELECT IF(idtm ~= "").
EXECUTE .

***** Aggregating tmappr09 at district level *****.

sort cases by country (a) region (a) district (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.SAV'
  /BREAK=country region district 
  /misdis= NMISS(tmappr09)   
  /numdis=N (idpupil)
  /opt1dis = PIN(tmappr09 1 1)
  /opt2dis = PIN(tmappr09 2 2)
  /opt3dis = PIN(tmappr09 3 3)
 
 .

***** Aggregating tmappr09 at region level *****.

sort cases by country (a) region (a) .

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.SAV'
  /BREAK=country region 
  /misreg= NMISS(tmappr09)   
  /numreg=N (idpupil)
  /opt1reg = PIN(tmappr09 1 1)
  /opt2reg = PIN(tmappr09 2 2)
  /opt3reg = PIN(tmappr09 3 3)
    .

***** Aggregating tmappr09 at country level *****.

sort cases by country (a).

AGGREGATE
  /OUTFILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.SAV'
  /BREAK=country 
  /miscon= NMISS(tmappr09)  
  /numcon=N (idpupil)
  /opt1con = PIN(tmappr09 1 1)
  /opt2con = PIN(tmappr09 2 2)
  /opt3con = PIN(tmappr09 3 3)
 
.

***** Merging back the aggregation *****.

GET
  FILE='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\bot_ken_les_mal_mau_moz_nam_sey_sou_swa_tan_uga_zam_zan.sav'.
EXECUTE .

FREQUENCIES
  VARIABLES=tmappr09 
  /ORDER  ANALYSIS .

sort cases by country (a) region (a) district (a)   .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGDIS.sav'
 /BY country region district .
EXECUTE.

sort cases by country (a) region (a)    .

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGREG.sav'
 /BY country region .
EXECUTE.

sort cases by    country (a).

MATCH FILES /FILE=*
 /table='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\AGCON.sav'
 /BY country .
EXECUTE.

sort cases by country (a) region (a) district (a)   .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

***** Calculating the missing percentage at each level *****.

compute misdisp= misdis/numdis.
compute misregp= misreg/numreg.
compute misconp= miscon/numcon.

EXECUTE .

***** Finding the Mode at each level *****.

if max(opt1dis, opt2dis, opt3dis)=opt3dis modedis=3.
if max(opt1dis, opt2dis, opt3dis)=opt2dis modedis=2.
if max(opt1dis, opt2dis, opt3dis)=opt1dis modedis=1.

if max(opt1reg, opt2reg, opt3reg)=opt3reg modereg=3.
if max(opt1reg, opt2reg, opt3reg)=opt2reg modereg=2.
if max(opt1reg, opt2reg, opt3reg)=opt1reg modereg=1.

if max(opt1con, opt2con, opt3con)=opt3con modecon=3.
if max(opt1con, opt2con, opt3con)=opt2con modecon=2.
if max(opt1con, opt2con, opt3con)=opt1con modecon=1.


***** Imputation of tmappr09 at district level *****.

if (idtm~="" and missing(tmappr09) and misdisp~= 0 and misdisp LT .15) tmappr09=modedis.

FREQUENCIES
  VARIABLES=tmappr09
  /ORDER  ANALYSIS .

***** Imputation of tmappr09 at region level *****.

if (idtm~="" and missing(tmappr09) and misdisp GE .15 and misregp~= 0 and misregp LT .15) tmappr09=modereg.

FREQUENCIES
  VARIABLES=tmappr09
  /ORDER  ANALYSIS .

***** Imputation of tmappr09 at country level *****.

if (idtm~="" and missing(tmappr09) and misdisp GE .15 and misregp GE .15 and misconp~= 0 and misconp LT .15) tmappr09=modecon.

FREQUENCIES
  VARIABLES=tmappr09
  /ORDER  ANALYSIS .

***** No imputation of tmappr09 if more than 15% missing at country level *****.

if (idtm~="" and missing(tmappr09) and misdisp GE .15 and misregp GE .15 and misconp GE .15) tmappr09=tmappr09.
FREQUENCIES
  VARIABLES=tmappr09
  /ORDER  ANALYSIS .

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\temp.sav'.

*****computing derived variables *****.

RECODE
  tmappr09
  (1=0)  (2=0)  (3=1)  INTO  ztmapp09 .
EXECUTE .

***** saving imputed variables *****.

sort cases by country (a) stratum (a) idpupil (a).

save outfile='I:\WORDPROC\MIOKO\SACMEQ2\SACMEQ II DATA\TQ45.09.sav' /keep country stratum idpupil tmappr09 ztmapp09 .

****Table 8.1(a) Percenttage indicating 'often used''*****.

SORT CASES BY country .
SPLIT FILE
  LAYERED BY country .

MEANS
  TABLES=ztmapp09  BY stratum
  /CELLS MEAN COUNT STDDEV  .
